package com.kronoscards.db;



import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.io.IOUtils;

import com.kronoscards.pack.Carta;






import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.os.AsyncTask;
import android.util.Log;



public class Database {
	 
	//Campos de la BD
	private Context context;
	private SQLiteDatabase db;
	private DataBaseHelper dbHelper;
	 private String DB_PATH = "";
	 private static String DB_NAME_OUT = "kronoscards.db";
		private String DB_NAME = "kronoscards.sqlite";
	 protected InitTaskCopiarBD copiarBasedeDatos;
 
	public Database(Context context) {
		this.context = context;
	}
 
	public boolean comprovarBasedeDades()
	{
		String destPath = context.getFilesDir().getPath();
	    DB_PATH = destPath.substring(0, destPath.lastIndexOf("/")) + "/databases/";
		boolean dbExist = checkDataBase();	
		if(!dbExist){	
			//Log.v("DB","No existeix bd copiem");
			copiarBasedeDatos = new InitTaskCopiarBD();
			copiarBasedeDatos.execute(context); 
		}
		return dbExist;		
	}
	private boolean checkDataBase(){
		  
		File f=new File(DB_PATH,DB_NAME_OUT);
		if (f.exists())
		{
			return true;
			
		}
		else return false;
}
	public Database open() throws SQLException {
		dbHelper = new DataBaseHelper(context);
		db = dbHelper.getReadableDatabase();
		return this;
	}
	public Database openRead() throws SQLException {
		dbHelper = new DataBaseHelper(context);
		db = dbHelper.getReadableDatabase();
		return this;
	}
	public Database openWrite() throws SQLException {
		dbHelper = new DataBaseHelper(context);
		db = dbHelper.getWritableDatabase();
		return this;
	}
	public void close() {
		db.close();
		dbHelper.close();
	}
	public Carta getCartaById(String id) {
		dbHelper = new DataBaseHelper(context); 
		try
		{	
		db = dbHelper.getReadableDatabase();	
		String[] args = new String[] {};	    
		Cursor cur = db.rawQuery("SELECT id,nivell,titol,descripcio,campo,any,pack,image FROM Cartes where id='"+id+"'",args);
		if (cur.moveToFirst())
		{
			
				Carta carta=new Carta();
				carta.setId(cur.getInt(0));
				carta.setNivell(cur.getInt(1));	
				carta.setTitulo(cur.getString(2));
				carta.setDescripcion(cur.getString(3));
				carta.setCampo(cur.getString(4));
				carta.setAny(cur.getString(5));
				carta.setPack(cur.getInt(6));
				carta.setImage(cur.getString(7));
			
			if (cur!=null) cur.close();
			if (db!=null) db.close();
			return carta;
		}else
		{
			if (cur!=null) cur.close();
			if (db!=null)db.close();
			return null;
		}
		}catch (SQLException e) {
			if (db!=null)db.close();
			return null;
		}	
	}
	
	public int getQttCartes()
	{
		dbHelper = new DataBaseHelper(context); 
		try
		{	
		db = dbHelper.getReadableDatabase();	
		String[] args = new String[] {};	    
		Cursor cur = db.rawQuery("SELECT count(*) FROM Cartes",args);
		if (cur.moveToFirst())
		{
			int qtt= cur.getInt(0);
			if (cur!=null) cur.close();
			if (db!=null) db.close();
			return qtt;
		}else
		{
			if (cur!=null) cur.close();
			if (db!=null)db.close();
			return -1;
		}
		}catch (SQLException e) {
			if (db!=null)db.close();
			return -1;
		}	
	}
	
	public List<Carta> getCartesWithImage() {
		List<Carta> cartasList=new ArrayList<Carta>();
		dbHelper = new DataBaseHelper(context); 
		try
		{	
		db = dbHelper.getReadableDatabase();	
		String[] args = new String[] {};	    
		Cursor cur = db.rawQuery("SELECT id,nivell,titol,descripcio,campo,any,pack,image FROM Cartes where image IS NOT NULL ORDER BY id",args);
		if (cur.moveToFirst())
		{
			do
			{
				Carta carta=new Carta();
				carta.setId(cur.getInt(0));
				carta.setNivell(cur.getInt(1));	
				carta.setTitulo(cur.getString(2));
				carta.setDescripcion(cur.getString(3));
				carta.setCampo(cur.getString(4));
				carta.setAny(cur.getString(5));
				carta.setPack(cur.getInt(6));
				carta.setImage(cur.getString(7));
				cartasList.add(carta);
			}while(cur.moveToNext());
			if (cur!=null) cur.close();
			if (db!=null) db.close();
			return cartasList;
		}else
		{
			if (cur!=null) cur.close();
			if (db!=null)db.close();
			return cartasList;
		}
		}catch (SQLException e) {
			if (db!=null)db.close();
			return cartasList;
		}	
	}
	
	public List<Carta> getAllCardsOrderByTime(boolean filterPack,int pack) {
		List<Carta> cartasList=new ArrayList<Carta>();
		dbHelper = new DataBaseHelper(context); 
		try
		{	
		db = dbHelper.getReadableDatabase();	
		String[] args = new String[] {};
		Cursor cur=null;
		if (filterPack) cur = db.rawQuery("SELECT id,nivell,titol,descripcio,campo,any,pack,image FROM Cartes WHERE pack='"+pack+"' AND any IS NOT NULL ORDER BY any",args);
		else cur = db.rawQuery("SELECT id,nivell,titol,descripcio,campo,any,pack,image FROM Cartes WHERE any IS NOT NULL ORDER BY any",args);
			
		if (cur.moveToFirst())
		{
			do
			{
				Carta carta=new Carta();
				carta.setId(cur.getInt(0));
				carta.setNivell(cur.getInt(1));	
				carta.setTitulo(cur.getString(2));
				carta.setDescripcion(cur.getString(3));
				carta.setCampo(cur.getString(4));
				carta.setAny(cur.getString(5));
				carta.setPack(cur.getInt(6));
				carta.setImage(cur.getString(7));
				cartasList.add(carta);
			}while(cur.moveToNext());
			if (cur!=null) cur.close();
			if (db!=null) db.close();
			return cartasList;
		}else
		{
			if (cur!=null) cur.close();
			if (db!=null)db.close();
			return cartasList;
		}
		}catch (SQLException e) {
			if (db!=null)db.close();
			return cartasList;
		}	
	}
	
	
	public List<Integer> getAllIdsOrderByTime(boolean filterPack,int pack) {
		List<Integer> idsList=new ArrayList<Integer>();
		dbHelper = new DataBaseHelper(context); 
		try
		{	
		db = dbHelper.getReadableDatabase();	
		String[] args = new String[] {};
		Cursor cur=null;
		if (filterPack) cur = db.rawQuery("SELECT id FROM Cartes WHERE pack='"+pack+"' AND any IS NOT NULL ORDER BY any",args);
		else cur = db.rawQuery("SELECT id FROM Cartes WHERE any IS NOT NULL ORDER BY any",args);
			
		if (cur.moveToFirst())
		{
			do
			{
				idsList.add(Integer.valueOf(cur.getInt(0)));
				
			}while(cur.moveToNext());
			if (cur!=null) cur.close();
			if (db!=null) db.close();
			return idsList;
		}else
		{
			if (cur!=null) cur.close();
			if (db!=null)db.close();
			return idsList;
		}
		}catch (SQLException e) {
			if (db!=null)db.close();
			return idsList;
		}	
	}
	 protected class InitTaskCopiarBD extends AsyncTask<Context, String, String> {
	      @Override
	      protected void onPreExecute() {
	    	  super.onPreExecute();
	           
	      }

	      @Override
	      protected String doInBackground(Context... params) {
	    	  try {
	  			copyDataBase();
	  			Log.v("DB","Base de dades copiada");
	  		} catch (IOException e) {
	  			Log.v("DB","IO exception No existeix bd copiem");
	  		}	  
	return "completo";
	      }

	      @Override
	      protected void onPostExecute(String unused) {
	    	
	      }
	  }
	 private void copyDataBase() throws IOException{
		  	
		  	File f=new File(DB_PATH);
		  	if(!f.exists()) 
			  {       
				  f.mkdirs();     
			  } 
		  	InputStream myInput = context.getAssets().open(DB_NAME);
		  	String outFileName = DB_PATH+DB_NAME_OUT;

		  	OutputStream myOutput = new FileOutputStream(outFileName);
		  	
		  	IOUtils.copy(myInput, myOutput);
		  	myOutput.flush();
		  	myOutput.close();
		  	myInput.close();
		  }

	



	

	
	
}

