package com.kronoscards.fragments;

import java.util.ArrayList;
import java.util.List;

import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.view.animation.AccelerateInterpolator;
import android.view.animation.DecelerateInterpolator;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;

import com.kronoscards.adaptscreen.AutoResizeTextView;
import com.kronoscards.adaptscreen.MyHorizontalScrollView;
import com.kronoscards.adaptscreen.OutlineTextView;
import com.kronoscards.kcmain.MainActivity;
import com.kronoscards.kcmain.R;
import com.kronoscards.pack.Carta;
import com.kronoscards.pack.UtilitatsTablero;
import com.nineoldandroids.animation.Animator;
import com.nineoldandroids.animation.AnimatorListenerAdapter;
import com.nineoldandroids.animation.AnimatorSet;
import com.nineoldandroids.animation.ObjectAnimator;

public class Fragment_RivalsCards extends Fragment {
	
	 MainActivity c;
	 View view;
	 ImageView btn_openRivalCards;
	 boolean isOpened=true;
	 boolean inAnimation=false;
	 MyHorizontalScrollView scroll;
	 RelativeLayout relGeneral;
	 boolean initValuesTranslation=false;
	 LinearLayout layoutInflate;
	 List<Integer> listOfCardsActual=new ArrayList<Integer>();
	  @Override
	   public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		       view = inflater.inflate(R.layout.fragment_rivalcards, container, false);
		       c=(MainActivity) getActivity();
		       relGeneral=(RelativeLayout)view.findViewById(R.id.rel_general_rivalcards);
		       scroll=(MyHorizontalScrollView)view.findViewById(R.id.scrollrivalcards);
		       layoutInflate=(LinearLayout)view.findViewById(R.id.linearinflaterivalcards);
		       btn_openRivalCards=(ImageView)c.findViewById(R.id.btn_rivalcards);
		       btn_openRivalCards.setOnClickListener(new OnClickListener(){

				@Override
				public void onClick(View v) {
					Log.v("Timeline","OnClick openRivalCards");
					if (isOpened&&!inAnimation)
					{
						close(false);
					}else if (!isOpened&&!inAnimation)
					{
						open(false);
					}
				}
		    	   
		       });
		       close(true);
		       return view;
	  }

	  private void initValuesTranslation()
	  {
		 // ImageView btn_rivalcards=(ImageView)c.findViewById(R.id.btn_rivalcards);
		  c.getAppValors().setQttTranslate((c.getAppValors().getScreenHeight()-btn_openRivalCards.getBottom()));
	
		  initValuesTranslation=true;
	  }
	  
	  public void open(final boolean quickly)
	  {
		  Log.v("Dades","RivalsCards  open");
		  if (!isOpened&&!inAnimation)
		  {		
			  reloadCartes(listOfCardsActual);
			  disableEnableAll(false);
			  if (!initValuesTranslation) initValuesTranslation();
			  ObjectAnimator translationY = ObjectAnimator.ofFloat((RelativeLayout) c.findViewById(R.id.relrivalcards), "translationY", -c.getAppValors().getQttTranslate(),0f);
			  if (quickly) translationY.setDuration(0);
				 else	 translationY.setDuration(500);
					 AnimatorSet translate= new AnimatorSet();
					 translate.setInterpolator(new DecelerateInterpolator());
				 translate.play(translationY);
				 translate.addListener(new AnimatorListenerAdapter() {
			         @Override
			         public void onAnimationEnd(Animator animation) {
			        	 Log.v("Dades","RivalsCards open onAnimationEnd");
			        	 isOpened=true;
			        	 inAnimation=false;
			        	 btn_openRivalCards.setImageResource(R.drawable.btn_rojo_up);
			        	 disableEnableAll(true);
			        	 OutlineTextView rivalCards=(OutlineTextView)c.findViewById(R.id.rivalname);
			        	 rivalCards.setTextColor(Color.argb(255, 185, 1, 27));
			        	 rivalCards.setText(c.getString(R.string.kronoscards_game_rivalnamepredef));
			      
			         }
			         @Override
			         public void onAnimationStart(Animator animation) {
			        	 relGeneral.setVisibility(View.VISIBLE);
			        	 inAnimation=true;
			        	 if (!quickly)  ((FrameLayout) c.findViewById(R.id.fragment_rivalcards)).setVisibility(View.VISIBLE);
			         }
			       });
				 translate.start(); 
		  }
	  }
	  public void close(final boolean quickly)
	  {
		  Log.v("Dades","RivalsCards close");
		  if (isOpened&&!inAnimation)
		  {			  
			  disableEnableAll(false);
			  if (!initValuesTranslation) initValuesTranslation();
			  ObjectAnimator translationY = ObjectAnimator.ofFloat((RelativeLayout) c.findViewById(R.id.relrivalcards), "translationY", 0f,-c.getAppValors().getQttTranslate());
			  
				 if (quickly) translationY.setDuration(0);
				 else	 translationY.setDuration(500);
					 AnimatorSet translate= new AnimatorSet();
					 translate.setInterpolator(new AccelerateInterpolator());
					 translate.play(translationY);
					
				 translate.addListener(new AnimatorListenerAdapter() {
			         @Override
			         public void onAnimationEnd(Animator animation) {
			        	 Log.v("Dades","RivalsCards close onAnimationEnd");
			        	 isOpened=false;
			        	 inAnimation=false;
			        	 btn_openRivalCards.setImageResource(R.drawable.btn_verde_down);
			        	 relGeneral.setVisibility(View.GONE);
			        	 disableEnableAll(true);
			        	 layoutInflate.removeAllViews();
					  		layoutInflate.removeAllViewsInLayout();
					  		OutlineTextView rivalCards=(OutlineTextView)c.findViewById(R.id.rivalname);
				        	 rivalCards.setTextColor(Color.argb(255, 0, 197, 0));
				        	 rivalCards.setText(c.getString(R.string.kronoscards_game_rivalnamepredef));
			        	 
			         }
			         @Override
			         public void onAnimationStart(Animator animation) {
			        	 inAnimation=true;
			        	  ((FrameLayout) c.findViewById(R.id.fragment_rivalcards)).setVisibility(View.VISIBLE);
			         }
			       });
				 translate.start(); 
		  }
	  }
	  public void disableEnableAll(boolean enable) {
			RelativeLayout relGeneral=(RelativeLayout)c.findViewById(R.id.reltotal);
			c.getUtils().disableEnableControls(enable, relGeneral);
			
		}
	  public int getNumCartesRestants()
	  {
		  return layoutInflate.getChildCount();
	  }
	  public void reloadCartes(List<Integer> listOfCards)
			{
		  if (listOfCards!=null&&listOfCards.size()>0)
		  {
			  listOfCardsActual=listOfCards;
			  	try
			  	{
			  		layoutInflate.removeAllViews();
			  		layoutInflate.removeAllViewsInLayout();
			  		 for (int i=0;i<listOfCards.size();i++)
			     		{
			     			inflateNewCard(listOfCards.get(i));
			     		}
			  	}catch (Exception e)
			  	{
			  		
			  	}
		  }else 
		  {
			  if (c.getFragmentTablero().isCreator())
			  {
				 // listOfCardsActual.add(c.getFragmentTablero().getiPartida().getCardsPerRepartir().get(location));
			  }else
			  {
				  
			  }
			  //Gestio treure cartes del rival en mode desempat
			 // listOfCardsActual.add(c.getFragmentTablero().getMyPlayer().getListCards().get(location));
		  }
			}
	  private void inflateNewCard(int id)
		{
			
					final Carta carta=c.getDatabase().getCartaById(""+id);
					 final RelativeLayout card=UtilitatsTablero.getRelForCard(carta, c, false);
					 card.setVisibility(View.VISIBLE);
					 final AutoResizeTextView titulo=(AutoResizeTextView)card.findViewById(R.id.titulo);
					 titulo.setVisibility(View.VISIBLE);		 
					 layoutInflate.addView(card);
		}

	public boolean isOpened() {
		return isOpened;
	}
	 @Override         	
	 public void onDestroyView() {
		 relGeneral.setVisibility(View.GONE);
	  Log.v("finish","onDestroyView RivalCards ");
	  layoutInflate.removeAllViews();
		super.onDestroyView();
  }
}
