package com.kronoscards.fragments;

import java.io.UnsupportedEncodingException;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.List;
import java.util.Locale;

import com.google.android.gms.games.Games;
import com.google.android.gms.games.multiplayer.realtime.RealTimeMessage;
import com.google.common.base.Joiner;
import com.google.common.base.Splitter;
import com.google.common.collect.Lists;
import com.google.gson.Gson;
import com.kronoscards.adaptscreen.AutoResizeTextView;
import com.kronoscards.adaptscreen.MyHorizontalScrollView;
import com.kronoscards.adaptscreen.OutlineTextView;
import com.kronoscards.kcmain.MainActivity;
import com.kronoscards.kcmain.R;
import com.kronoscards.pack.Carta;
import com.kronoscards.pack.InfoPartida;
import com.kronoscards.pack.OpcionsPartida;
import com.kronoscards.pack.Player;
import com.kronoscards.pack.ResultatPartida;
import com.kronoscards.pack.UtilitatsTablero;
import com.kronoscards.satelitemenu.SatelliteMenu;
import com.nineoldandroids.animation.Animator;
import com.nineoldandroids.animation.AnimatorListenerAdapter;
import com.nineoldandroids.animation.AnimatorSet;
import com.nineoldandroids.animation.ObjectAnimator;

import android.annotation.SuppressLint;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.view.animation.AccelerateInterpolator;
import android.view.animation.LinearInterpolator;
import android.widget.Button;
import android.widget.HorizontalScrollView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

public class Fragment_Tablero  extends Fragment {
	
	 MainActivity c;
	 View view;
	 LinearLayout tablero;
	 RelativeLayout relGeneral;
	 MyHorizontalScrollView scroll;
	 
	 List<Integer> listCardsIds=new ArrayList<Integer>();
	 List<Carta> listCardsTotals=new ArrayList<Carta>();
	 
	
	 
	 OpcionsPartida oPartida=new OpcionsPartida();
	 InfoPartida iPartida=new InfoPartida();
	 
	 
	 //Opcions de partida
	  private boolean isCreator=false;
	    private boolean partidaIniciada=false;
	    private boolean isMyTurn=false;
	    String idCreador="";
	    String mMyId = null;
	    Player myPlayer=new Player();
	    Carta cartaToAdd;
	    int counterTourn=1;
	   // int widthSatelite=0;
	    int maxElements=1;
	    int maxNumCards=253;
	    RelativeLayout menuMyCards;
	    private boolean isTurnFinished=false;
	    private boolean stateGenerateCardPlayer=false;
	    private boolean stateAddCard=false;
	    private boolean stateIsAddingCardToGame=false;
	    private boolean stateIsFinishTime=false;
	    private boolean isWinner=false;
	    private RelativeLayout relButtonToReplace;
	    private boolean isMatchBall=false;
	  
	 
	  @Override
	   public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		       view = inflater.inflate(R.layout.fragment_tablero, container, false);
		       c=(MainActivity) getActivity();	
		       c.setNumFragment(5);
		       tablero=(LinearLayout)view.findViewById(R.id.linearinflate);
		       menuMyCards=(RelativeLayout)c.findViewById(R.id.relmycards);
		       relGeneral=(RelativeLayout)view.findViewById(R.id.reltablero);
		       scroll=(MyHorizontalScrollView)view.findViewById(R.id.scrolltablero);
		       scroll.setEnableScrolling(false);
		     
		       
		       maxNumCards=c.getDatabase().getQttCartes();
		       //Preconfiguracions
		       oPartida.setNumCardsByPlayer(c.getAppValors().getPrefsKC().getInt("maxNumInMano", 4));
		       oPartida.setNumInitialCards(c.getAppValors().getPrefsKC().getInt("cardsInTablero", 1));
		       oPartida.setMaxCards(c.getAppValors().getPrefsKC().getInt("maxNumCards", 20));
		       oPartida.setPermitirDesempate(c.getAppValors().getPrefsKC().getBoolean("desempate", false));
		       oPartida.setPaquetCartes(c.getAppValors().getPrefsKC().getInt("paquete", 0));
		       oPartida.setDificultat(c.getAppValors().getPrefsKC().getInt("dificultat", 1));
		       oPartida.setTiempoTurno(c.getAppValors().getPrefsKC().getInt("tiempo", 60));
		       //iPartida.setCartesInicials(new Integer[]{19,52,55,56,91});
		       if (oPartida.getPaquetCartes()==0)
		    	   listCardsTotals=c.getDatabase().getAllCardsOrderByTime(false, -1);
		       else
		    	   listCardsTotals=c.getDatabase().getAllCardsOrderByTime(true, oPartida.getPaquetCartes());
		       Log.v("Partida","LLista de cartes totals= "+listCardsTotals);
		      // List<Integer> listTotalsIds=new ArrayList<Integer>();
		       UtilitatsTablero.listCartas=listCardsTotals;
		       UtilitatsTablero.init(c);
		       c.stopDialog();
		       c.initPuntuacioLastPartida();
		       /*for(Carta carta:listCardsTotals)
		       {
		    	   listTotalsIds.add(carta.getId());
		       }*/
		       //iPartida.setCartesInicials(listTotalsIds.toArray(new Integer[listTotalsIds.size()]));
		       return view;
	  }
		  
	  public OpcionsPartida getoPartida() {
		return oPartida;
	}
	public void setoPartida(OpcionsPartida oPartida) {
		this.oPartida = oPartida;
	}
	public InfoPartida getiPartida() {
		return iPartida;
	}
	public void setiPartida(InfoPartida iPartida) {
		this.iPartida = iPartida;
	}
	public boolean isCreator() {
		return isCreator;
	}
	public boolean isMyTurn() {
		return isMyTurn;
	}
	public boolean isMathBall() {
		return isMatchBall;
	}
	
	public boolean isStateGenerateCardPlayer() {
		return stateGenerateCardPlayer;
	}

	public void setStateGenerateCardPlayer(boolean stateGenerateCardPlayer) {
		this.stateGenerateCardPlayer = stateGenerateCardPlayer;
	}

	public boolean isStateAddCard() {
		return stateAddCard;
	}

	public void setStateAddCard(boolean stateAddCard) {
		this.stateAddCard = stateAddCard;
	}

	public boolean isStateIsAddingCardToGame() {
		return stateIsAddingCardToGame;
	}

	public void setStateIsAddingCardToGame(boolean stateIsAddingCardToGame) {
		this.stateIsAddingCardToGame = stateIsAddingCardToGame;
	}

	public boolean isStateIsFinishTime() {
		return stateIsFinishTime;
	}

	public void setStateIsFinishTime(boolean stateIsFinishTime) {
		this.stateIsFinishTime = stateIsFinishTime;
	}

	public boolean isAllStatesOff()
	{
		if (!stateGenerateCardPlayer&&!stateAddCard&&!stateIsFinishTime&&!stateIsAddingCardToGame) return true;
		else return false;
	}
	public void setAllStatesOff()
	{
		stateGenerateCardPlayer=false;
		stateAddCard=false;
		stateIsFinishTime=false;
		stateIsAddingCardToGame=false;
	}
	/*public void initMyCards() {
		 c.getFragmentMyCards().open(false);
      	 ((RelativeLayout)c.findViewById(R.id.relmycards)).setVisibility(View.VISIBLE);
      	Handler handler = new Handler(); 
	 	    handler.postDelayed(new Runnable() { 
	 	         public void run() {
	 	        	c.getFragmentMyCards().initFragment(myPlayer.getListCards());
			 	      }
		 	       }, 500);
	}*/
	public void initTablero()
	  {	
		  Log.v("MyCards","initTablero()");
		Handler handler = new Handler(); 
	    handler.postDelayed(new Runnable() { 
	         public void run() {
	        	 c.getFragmentHeather().showMessage(c.getString(R.string.kronoscards_game_reparttablero));
	        	 c.getFragmentMyCards().close(false,true);	
				 	    
				if (isCreator) isMyTurn=true;
				else isMyTurn=false;
				  RelativeLayout viewSatellite = UtilitatsTablero.getNewSatelliteMenu(c);			 
					 viewSatellite.setVisibility(View.GONE);
					 tablero.addView(viewSatellite);
					for (int i=0;i<iPartida.getCartesInicials().length;i++)
					{
						final int j=i;
					     Handler handler = new Handler(); 
				 	    handler.postDelayed(new Runnable() { 
				 	         public void run() { 
				 	        	 RelativeLayout card1=getInitialCard(iPartida.getCartesInicials()[j]);			 
				 				 AutoResizeTextView ano=(AutoResizeTextView)card1.findViewById(R.id.ano);
				 				 ano.setVisibility(View.INVISIBLE);
				 				 tablero.addView(card1);
				 				listCardsIds.add(iPartida.getCartesInicials()[j]);
				 				 startFirstAnimation(card1);
				 				 RelativeLayout viewSatellite2 = UtilitatsTablero.getNewSatelliteMenu(c);
				 				 viewSatellite2.setVisibility(View.GONE);
				 				 tablero.addView(viewSatellite2);
				 				ObjectAnimator animator=ObjectAnimator.ofInt(scroll, "scrollX",((int)scroll.getScrollX()+300)).setDuration(500);
			 					animator.start();
			 					if (j==(iPartida.getCartesInicials().length-1)) 
			 					{
			 						Handler handler = new Handler(); 
			 				 	    handler.postDelayed(new Runnable() { 
			 				 	         public void run() {
			 				 	        	c.getFragmentHeather().finishRepartirCartes();
			 				 	        	Log.v("Timeline", "Finish tablero, obrim les meves cartes");
			 				 	        	/* c.getFragmentMyCards().open(false);
			 				 	        	 scroll.setEnableScrolling(true);
			 				 	        	 ((RelativeLayout)c.findViewById(R.id.relmycards)).setVisibility(View.VISIBLE);
			 				 	        	Handler handler = new Handler(); 
			 		 				 	    handler.postDelayed(new Runnable() { 
			 		 				 	         public void run() {
					 				 	        	c.getFragmentMyCards().initFragment(myPlayer.getListCards());
					 		 				 	      }
					 	 				 	       }, 500);*/
			 				 	         }
			 				 	       }, 500);
			 					}		 			
				 	         } 
				 	         
				 	    }, 700+(i*700));
					}
	         }
	       }, 2000);
			
			
	  }
	public void checkCard(RelativeLayout rel)
	{
		relButtonToReplace=rel;
		int positionButton=tablero.indexOfChild(rel);
		if (positionButton==0)
		{
			int idCarta=listCardsIds.get(0);
			Carta cartaCompare=c.getDatabase().getCartaById(""+idCarta);//getCardById(idCarta);
			Log.v("Check","idCarta a reemplaar "+idCarta);
			if (cartaCompare==null) Log.v("Check","cartaCompare==null)");
			if (cartaToAdd==null) Log.v("Check","cartaToAdd==null)");
			if (Long.parseLong(cartaToAdd.getAny().trim())<=Long.parseLong(cartaCompare.getAny().trim()))
			{
				Log.v("Check","Any carta to add= "+Long.parseLong(cartaToAdd.getAny()));
				Log.v("Check","Any cartaCompare to add= "+Long.parseLong(cartaCompare.getAny().trim()));
				c.getFragmentHeather().uploadPuntuacioMeva((20+getPuntuacioPerDistancia(Math.abs(Long.parseLong(cartaToAdd.getAny().trim())-Long.parseLong(cartaCompare.getAny().trim())))));
				Log.v("Puntuacio","Nova puntuacio= " +c.getFragmentHeather().getMiPuntuacio());
				replaceElement(rel,0);				
				Toast.makeText(c.getApplicationContext(), "Correcte", 
						   Toast.LENGTH_LONG).show();
			}else
			{
				generateNewCard();
				Toast.makeText(c.getApplicationContext(), "Incorrecte", 
						   Toast.LENGTH_LONG).show();
			}
		}else if (positionButton==tablero.getChildCount()-1)
		{
			Log.v("Check","Es l'ultim del layout");
			int idCarta=listCardsIds.get(listCardsIds.size()-1);
			Carta cartaCompare=c.getDatabase().getCartaById(""+idCarta);
			if (Long.parseLong(cartaToAdd.getAny().trim())>=Long.parseLong(cartaCompare.getAny().trim()))
			{
				Log.v("Check","Any carta to add= "+Long.parseLong(cartaToAdd.getAny().trim()));
				Log.v("Check","Any cartaCompare to add= "+Long.parseLong(cartaCompare.getAny().trim()));
				c.getFragmentHeather().uploadPuntuacioMeva((20+getPuntuacioPerDistancia(Math.abs(Long.parseLong(cartaToAdd.getAny().trim())-Long.parseLong(cartaCompare.getAny().trim())))));
				Log.v("Puntuacio","Nova puntuacio= " +c.getFragmentHeather().getMiPuntuacio());
				replaceElement(rel,listCardsIds.size());
				Toast.makeText(c.getApplicationContext(), "Correcte", 
						   Toast.LENGTH_LONG).show();
			}else
			{
				generateNewCard();
				Toast.makeText(c.getApplicationContext(), "Incorrecte", 
						   Toast.LENGTH_LONG).show();
			}
		}else
		{
			Log.v("Check","Estic en mig");
			int positionCartaScroll=positionButton/2;
			int idCartaLeft=listCardsIds.get(positionCartaScroll-1);
			int idCartaRight=listCardsIds.get(positionCartaScroll);
			Carta cartaCompareRight=c.getDatabase().getCartaById(""+idCartaRight);			
			Carta cartaCompareLeft=c.getDatabase().getCartaById(""+idCartaLeft);
			Log.v("Check","Any carta to add= "+Long.parseLong(cartaToAdd.getAny().trim()));
			Log.v("Check","Any cartaCompareLeft to add= "+Long.parseLong(cartaCompareLeft.getAny().trim()));
			Log.v("Check","Any cartaCompareRight to add= "+Long.parseLong(cartaCompareRight.getAny().trim()));
		
			if (Long.parseLong(cartaToAdd.getAny().trim())>=Long.parseLong(cartaCompareLeft.getAny().trim())&&Long.parseLong(cartaToAdd.getAny().trim())<=Long.parseLong(cartaCompareRight.getAny().trim()))
			{
				Log.v("Check","Any carta to add= "+Long.parseLong(cartaToAdd.getAny().trim()));
				Log.v("Check","Any cartaCompareLeft to add= "+Long.parseLong(cartaCompareLeft.getAny().trim()));
				Log.v("Check","Any cartaCompareRight to add= "+Long.parseLong(cartaCompareRight.getAny().trim()));
				int puntuacioLeft=getPuntuacioPerDistancia(Math.abs(Long.parseLong(cartaCompareLeft.getAny().trim())-Long.parseLong(cartaCompareLeft.getAny().trim())));
				int puntuacioRight=getPuntuacioPerDistancia(Math.abs(Long.parseLong(cartaCompareLeft.getAny().trim())-Long.parseLong(cartaCompareRight.getAny().trim())));
				Log.v("Puntuacio","Nova puntuacioLeft= " +puntuacioLeft);
				Log.v("Puntuacio","Nova puntuacioRight= " +puntuacioRight);
				c.getFragmentHeather().uploadPuntuacioMeva((20+puntuacioLeft+puntuacioRight));
				replaceElement(rel,positionCartaScroll);
				
				Toast.makeText(c.getApplicationContext(), "Correcte", 
						   Toast.LENGTH_LONG).show();
			}else
			{
				generateNewCard();
				Toast.makeText(c.getApplicationContext(), "Incorrecte", 
						   Toast.LENGTH_LONG).show();
			}
		}
	}
	private int getPuntuacioPerDistancia(Long distancia)
	{
		if (distancia<=1) return 30;
		else if (distancia<=5) return 20;
		else if (distancia<=10) return 10;
		else if (distancia<=100) return 5;
		else return 0;
	}
	private void generateNewCard()
	{
		if (!isTurnFinished)
		{
			isTurnFinished=true;
			stateGenerateCardPlayer=true;			
			c.getFragmentHeather().stopCuentaAtras();
			c.getFragmentHeather().resetMiniCard();
			setAllMenusState(false);	
			c.getUtils().disableEnableControls(false, relGeneral);		
			menuMyCards.setVisibility(View.VISIBLE);
			if (!c.getFragmentMyCards().isOpened())c.getFragmentMyCards().open(false);
			Handler handler2 = new Handler(); 
		    handler2.postDelayed(new Runnable() { 
		         public void run() {
		        	 c.getFragmentMyCards().addCardError();
		         } 
		    }, 500);
		}
		
		
	}
	private void replaceElement(final RelativeLayout rel,final int position)
	{
		if (!isTurnFinished)
		{	
			c.getFragmentHeather().stopCuentaAtras();
			isTurnFinished=true;
			stateAddCard=true;								
				c.getUtils().disableEnableControls(false, relGeneral);
				c.getFragmentMyCards().deleteCarta();
			    Handler handler2 = new Handler(); 
			    handler2.postDelayed(new Runnable() { 
			         public void run() {	        	 
			        	 setAllMenusState(false);
			        	 Log.v("Carta","replaceElement rel id= "+rel.getId());
			     		maxElements=tablero.getChildCount();
			     		Log.v("Carta","maxElements= "+maxElements);
			     		//final int positionInLayout=rel.getId()-1;
			     		final int positionInLayout=tablero.indexOfChild(rel);
			     		Log.v("Carta","positionInLayout= "+positionInLayout);
			     		 RelativeLayout card1=getNewCard(position);
			     		card1.setVisibility(View.VISIBLE);
			     		// layoutInflate.removeView(rel);
			     		 
			     		 if (positionInLayout==0)
			     		 {
			     			 RelativeLayout viewSatellite = UtilitatsTablero.getNewSatelliteMenu(c);
			     			 viewSatellite.setVisibility(View.GONE);
			     			tablero.addView(card1, 1);
			     			tablero.addView(viewSatellite,2);
			     			
			     		 }else if (positionInLayout==maxElements-1)
			     		 {
			     			 RelativeLayout viewSatellite = UtilitatsTablero.getNewSatelliteMenu(c);
			     			 viewSatellite.setVisibility(View.GONE);
			     			tablero.addView(card1, maxElements);
			     			tablero.addView(viewSatellite,maxElements+1);
			     		 }else
			     		 {
			     			 RelativeLayout viewSatellite = UtilitatsTablero.getNewSatelliteMenu(c);
			     			 viewSatellite.setVisibility(View.GONE);
			     			tablero.addView(card1, positionInLayout+1);
			     			tablero.addView(viewSatellite,positionInLayout+2); 
			     		 }
			     		Handler handler2 = new Handler(); 
			    	    handler2.postDelayed(new Runnable() { 
			    	         public void run() {
			    	        	   nextTurn2(false,positionInLayout,false);
			    	        	 } 
			    	    }, 1000);	
		
		
			         } 
			    }, 1000);
		}
	    }
	@SuppressLint("NewApi")
	private RelativeLayout getNewCard(int position)
	{
		
		int numCard;
		int idCard=-1;
		Carta carta=null;
		if (cartaToAdd!=null)
		{
			Log.v("Partida","Position= "+position);
			listCardsIds.add(position,cartaToAdd.getId());
			carta=cartaToAdd;
			Log.v("Partida","getNewCard add new id= "+carta.getId());
		}else
		{
			/*do
			{
				numCard=getRandom(0,listCartas.size()-1);
				idCard=listCartas.get(numCard).getId();
			
			}while (listCardsIds.contains(idCard));
			listCardsIds.add(idCard);
			carta=listCartas.get(numCard);*/
		}
		 
		return UtilitatsTablero.getRelForCard(carta,c,true);
	}
	  private void startFirstAnimation(final RelativeLayout firstCard)
		{
		ObjectAnimator scaleX = ObjectAnimator.ofFloat(firstCard, "scaleX", 0f,1f);
		 ObjectAnimator scaleY = ObjectAnimator.ofFloat(firstCard, "scaleY", 0f,1f);
		 scaleX.setDuration(500);
		 scaleX.setInterpolator(new AccelerateInterpolator());
		 scaleY.setDuration(500);
		 scaleY.setInterpolator(new AccelerateInterpolator());
		 AnimatorSet scale= new AnimatorSet();
		 scale.play(scaleX).with(scaleY);
		
		 scale.addListener(new AnimatorListenerAdapter() {
				
	       @Override
	       public void onAnimationEnd(Animator animation) {
	       	final AutoResizeTextView ano=(AutoResizeTextView)firstCard.findViewById(R.id.ano);
	      	 ObjectAnimator translationX = ObjectAnimator.ofFloat(ano, "alpha", 0f,1f);
	      	 
	      	 translationX.setDuration(1500);
	      	 translationX.setInterpolator(new LinearInterpolator());
	      	
	      	 AnimatorSet translate1= new AnimatorSet();
	      	 translate1.play(translationX);
	      	
	      	 translate1.addListener(new AnimatorListenerAdapter() {
	      			
	              @Override
	              public void onAnimationEnd(Animator animation) {            	
	              }
	              @Override
	              public void onAnimationStart(Animator animation) {
	             	 ano.setVisibility(View.VISIBLE);
	              }
	             
	            });
	      	 translate1.start();
	       }
	       @Override
	       public void onAnimationStart(Animator animation) {		
	    	   firstCard.setVisibility(View.VISIBLE);
	       }
	      
	     });
		 firstCard.setVisibility(View.VISIBLE);
		 scale.start();
	}
	  public void setAllMenusState(boolean visible)
	    {
	    	for(int i=0; i<tablero.getChildCount(); i++) {
				RelativeLayout mChild = (RelativeLayout) tablero.getChildAt(i);
				View v=tablero.getChildAt(i);
				 if (mChild instanceof RelativeLayout) {
					 RelativeLayout rel=(RelativeLayout)v;
					 if (rel.getTag()!=null&&rel.getTag().toString().compareTo("Menu")==0)
					 {
						 if (visible) rel.setVisibility(View.VISIBLE);
						 else 
						 {
							 rel.setVisibility(View.GONE);
						 }
					 }
				 }
	    	}
	    }
	
	  private RelativeLayout getInitialCard(int id)
		{
			//listCardsIds.add(id);
			Carta carta=c.getDatabase().getCartaById(""+id);
			//c.getUtilsTablero();
			return UtilitatsTablero.getRelForCard(carta,c,true);
		}
		
	  public void setCreatorValues(boolean isCreator) {
		  Log.v("Partida","setCreatorValues isCreator=  "+isCreator);
		  myPlayer.setCreator(isCreator);
	    	this.isCreator=isCreator;		  
	        partidaIniciada=false;
			
		}
	  public Player getMyPlayer() {
			// TODO Auto-generated method stub
			return myPlayer;
		}
	  //Gestions Game
	  
	  void startTurn()
		{		
		   isMyTurn=true;
			 Log.v("Partida","onClick startTurn ");
			if (c.getFragmentMyCards()!=null) c.getFragmentMyCards().activateAll();
		}
	  
	
	  public void addCardToGame(Carta carta,Bitmap bm) {
		  stateIsAddingCardToGame=true;
		  cartaToAdd=carta;
		  setAllMenusState(true);		  
		  c.getFragmentHeather().addCardToGame(bm);
		  c.getUtils().disableEnableControls(true, relGeneral);
		  if (c.getFragmentMyCards().isOpened()) c.getFragmentMyCards().close(false,false);
		  if (c.getFragmentRivalCards().isOpened()) c.getFragmentRivalCards().close(false);
		}
	  public void closeAllButtons()
		{
			for(int i=0; i<tablero.getChildCount(); i++) {
				RelativeLayout mChild = (RelativeLayout) tablero.getChildAt(i);
				View v=tablero.getChildAt(i);
				 if (mChild instanceof RelativeLayout) {
					 RelativeLayout rel=(RelativeLayout)v;
					 if (rel.getTag()!=null&&rel.getTag().toString().compareTo("Menu")==0)
					 {
						 SatelliteMenu menu=(SatelliteMenu)rel.findViewById(R.id.menu1);
						 if (menu.isActivate())
						 {
							 menu.close();
							 Log.v("Scroll","menu.isActivated()");
						 }
					 }
			}
			}
		}
	  public void finishReplaceCard() {
			c.getFragmentHeather().switchTurnView(false);
			nextTurn2(true,-1,false);
			
		}
	  public void finishCuentaAtras() {
		 
		
		  if (!isTurnFinished)
		  {
			  stateIsFinishTime=true;
			  isTurnFinished=true;
			  c.getFragmentHeather().switchTurnView(false);
			  nextTurn2(true,-1,true);
		  }
			
		}
	  public void finishCards() {
		  
		  //
		  //stateFinishGame(false);
			
		}
	  public void finishMissatgeAnimat(boolean winner) {
		  finPartida(winner);
			
		}
		private void finPartida(boolean isWinner)
		{
			Log.v("States","finPartida called");
			this.isWinner=isWinner;
			
			c.leaveRoom(false);
		}

		public void setPartidaIniciadaState(boolean state) {
			Log.v("Partida","setPartidaIniciadaState "+state);
			partidaIniciada=state;
			
		}

		public void onRealTimeMessageReceived2(RealTimeMessage message) {
		//	if (iPartida.getNumMissatge()>0) boolean checkMessage=
					
			isTurnFinished=false;
			if (!partidaIniciada)
	    	{
				    		Log.v("Partida","partida no Iniciada");
				    		Log.v("Partida","es creador = "+isCreator);
				    		if (isCreator)
				    		{			    			
				    			 byte[] buf = message.getMessageData();
								 String sender = message.getSenderParticipantId();			    		        
				    		        String infoP="No init";
									try {
										infoP = new String(buf, "UTF-8");
									} catch (UnsupportedEncodingException e) {
										infoP="No init";
									}
									if (infoP.compareTo("No init")!=0)
									{
									}
									Gson gson = new Gson();  								
									InfoPartida iPartidaTemp=new InfoPartida();
									iPartidaTemp = gson.fromJson(infoP, InfoPartida.class);
									if (iPartidaTemp.isCartesRebudesByOther())
									{
										 gestioPartidaIniciada();
									}			    			
				    		       
				    		}else
				    		{
				    			 Log.v("Partida","No soc el creador rebo missatge");
				    			 byte[] buf = message.getMessageData();
								 String sender = message.getSenderParticipantId();
				    		        
				    		        String infoP="No init";
									try {
										infoP = new String(buf, "UTF-8");
									} catch (UnsupportedEncodingException e) {
										infoP="No init";
									}
									if (infoP.compareTo("No init")!=0)
									{
										Gson gson = new Gson();  
									
										iPartida=new InfoPartida();
										iPartida = gson.fromJson(infoP, InfoPartida.class);
										oPartida=iPartida.getOpcions();
										Log.v("Partida","Carta inicial rebuda= "+Arrays.toString(iPartida.getCartesInicials()));
										Log.v("Partida","Cartas per repartir= "+Joiner.on(",").join(iPartida.getCardsPerRepartir()));
										 myPlayer.setListCards(iPartida.getCardsPerRepartir());
										 iPartida.setCartesRebudesByOther(true);
										 iPartida.setNumMissatge(iPartida.getNumMissatge()+1);
										 c.getFragmentRivalCards().reloadCartes(iPartida.getListCardsByCreator());
										 gson = new Gson();   
											String info = gson.toJson(iPartida);   
								    	 Log.v("Partida","Info a enviar a l'altre= "+info);
								    	 byte[] mMsgPartida=info.getBytes();
								    	 c.enviarMissatgeReliable(mMsgPartida);
						    		      gestioPartidaIniciada();
										 
									}
									
									
				    		}
				    	}else
				    	{
				    		
				    		Log.v("States","Partida iniciada rebo missatge amb cartes");
				    		 byte[] buf = message.getMessageData();
							 String sender = message.getSenderParticipantId();
							  String infoP="No init";
								try {
									infoP = new String(buf, "UTF-8");
								} catch (UnsupportedEncodingException e) {
									infoP="No init";
								}
								if (infoP.compareTo("No init")!=0)
								{
									 Log.v("States","Rebo nou missatge!!!!");
									boolean isPreviousFinishGame=iPartida.isStateFinishGame();
									Gson gson = new Gson();  
									 Log.v("States","Soc creador?= "+isCreator);
									iPartida=new InfoPartida();
									iPartida = gson.fromJson(infoP, InfoPartida.class);
									
									if (isCreator) 
									{
										c.getFragmentHeather().uploadPuntuacioRival(iPartida.getPuntuacioRival());
									}else c.getFragmentHeather().uploadPuntuacioRival(iPartida.getPuntuacioCreador());
									
									if (isCreator)
									{
										 Log.v("States","Soc creador?= "+isCreator);
										//Rebo missatge i soc el creador
										if (isPreviousFinishGame)
										{
											Log.v("States","isPreviousFinishGame");
											//Si havia acabat abans la partida
											if (iPartida.isStateFinishGame())
											{
												Log.v("States","iPartida.isStateFinishGame()");
												//La partida s'ha acabat perque ha fallat
												//o perque ha acertat i no hi ha desempat
												if (iPartida.isErrorTurn())
												{
													ResultatPartida resultat=new ResultatPartida();
													resultat.setWinner(true);
													resultat.setPerfect(c.getFragmentMyCards().isPerfect());
													resultat.setPuntuacioTotal(c.getFragmentHeather().getMiPuntuacio());
													c.setPuntuacioFinal(resultat);
													Log.v("States","iPartida.isErrorTurn() guanyem");
													//L'altre ha fallat hem guanyat
													 c.getFragmentHeather().startMissatgeAnimat(c.getString(R.string.kronoscards_finishgame_win),true,true);
													 
												}else
												{
													Log.v("States","no hi ha error finish per puntuacio");
													
													ResultatPartida resultat=new ResultatPartida();
													if (c.getFragmentHeather().getMiPuntuacio()>=c.getFragmentHeather().getRivalPuntuacio())
														resultat.setWinner(true);
													else resultat.setWinner(false);
													resultat.setPerfect(c.getFragmentMyCards().isPerfect());
													resultat.setPuntuacioTotal(c.getFragmentHeather().getMiPuntuacio());
													c.setPuntuacioFinal(resultat);
													//L'altre ha acertat finalitzem per puntuacio
													 c.getFragmentHeather().startMissatgeAnimat(c.getString(R.string.kronoscards_finishgame_winp),false,true);
												}
													
											}else
											{
												Log.v("States","generateNewCardDesempate");
												//La partida no s'ha acabat entrem en mode desempat
												generateNewCardDesempate();
												
											}
										}else
										{
											Log.v("States","No he guanyat abans");
											if (iPartida.isStateFinishGame())
											{
												Log.v("States","L'altre si que ha acabat perdem");
												//L'altre ha acertat hem perdut
												ResultatPartida resultat=new ResultatPartida();
												resultat.setPuntuacioTotal(c.getFragmentHeather().getMiPuntuacio());
												c.setPuntuacioFinal(resultat);
												 c.getFragmentHeather().startMissatgeAnimat(c.getString(R.string.kronoscards_finishgame_lose),false,true);
										
											}else
											{
												Log.v("States","L'altre no ha acabat turn normal");
												//L'altre no ha acabat comencem el turn normal
												startTurnNormal();
											}
										}
									}else
									{
										Log.v("States","No soc el creador");
										//No soc el creador
										if (c.getFragmentMyCards().getNumCartesRestants()==0)
										{
											Log.v("States","No em queden cartes");
											generateNewCardDesempate();
										}else
										{
											if (iPartida.isStateFinishGame()&&c.getFragmentMyCards().getNumCartesRestants()>1)
											{
												ResultatPartida resultat=new ResultatPartida();
												resultat.setPuntuacioTotal(c.getFragmentHeather().getMiPuntuacio());
												c.setPuntuacioFinal(resultat);
										
												 c.getFragmentHeather().startMissatgeAnimat(c.getString(R.string.kronoscards_finishgame_lose),false,true);
											}else
											{
											Log.v("States","startTurnNormal");
												startTurnNormal();
											}
										}
											
										
										
									}
									
								
									 
								}
							
				    	}
				}
		private void startTurnNormal()
		{
			if (isCreator)
			{
				 c.getFragmentRivalCards().reloadCartes(iPartida.getListCardsByOtherPlayer());
				 if (c.getFragmentMyCards().getNumCartesRestants()==1&&iPartida.getListCardsByOtherPlayer().size()>1)
					 isMatchBall=true;				 
				 else isMatchBall=false;
			}else
			{
				 c.getFragmentRivalCards().reloadCartes(iPartida.getListCardsByCreator());
				 if (c.getFragmentMyCards().getNumCartesRestants()==1&&iPartida.getListCardsByCreator().size()>1)
					 isMatchBall=true;
				 else if (c.getFragmentMyCards().getNumCartesRestants()==1&&iPartida.isErrorTurn())
					 isMatchBall=true;
				 else isMatchBall=false;
			}
			counterTourn=iPartida.getTurnCounter();
			  Log.v("Partida","torn rebut="+counterTourn);
			  c.getFragmentHeather().setTurnIndicator(counterTourn);
			if (iPartida.isErrorTurn())
			{
				
				 Log.v("Partida","iPartida.isErrorTurn()=  "+iPartida.isErrorTurn()+ " no s'ha d'afegir carta");
				 c.getFragmentHeather().switchTurnView(true);
			}else
			{
				addNewCardToMyScroll();
				
				  Log.v("Partida","iPartida.isErrorTurn()=  "+iPartida.isErrorTurn());
			}
		}
		private void generateNewCardDesempate()
		{
			 c.getFragmentMyCards().open(false);
	        	 scroll.setEnableScrolling(true);
	        	 ((RelativeLayout)c.findViewById(R.id.relmycards)).setVisibility(View.VISIBLE);
	        	Handler handler = new Handler(); 
		 	    handler.postDelayed(new Runnable() { 
		 	         public void run() {
		 	        	 c.getFragmentMyCards().generateNewCardDesempate();
				 	      }
			 	       }, 500);
		
		}
		public void finishAddCardDesempate() {
			c.getFragmentRivalCards().reloadCartes(iPartida.getListCardsByOtherPlayer());
			 counterTourn=iPartida.getTurnCounter();
			 c.getFragmentHeather().setTurnIndicator(counterTourn);
				if (iPartida.isErrorTurn())
				{
					
					 Log.v("Partida","iPartida.isErrorTurn()=  "+iPartida.isErrorTurn()+ " no s'ha d'afegir carta");
					 c.getFragmentHeather().switchTurnView(true);
				}else
				{
					addNewCardToMyScroll();
					
					  Log.v("Partida","iPartida.isErrorTurn()=  "+iPartida.isErrorTurn());
				}
			
		}
	
	
		
		private void gestioFinishTime()
		{
			c.getFragmentMyCards().disableEnableAll(true);
			if (stateGenerateCardPlayer)
			{
				
				isTurnFinished=false;
				generateNewCard();
			}else if (stateAddCard)
			{
				isTurnFinished=false;
				checkCard(relButtonToReplace);
			}else if (stateIsAddingCardToGame)
			{
				isTurnFinished=false;
				cancelMiniCard();
				 cartaToAdd=null;
				  setAllMenusState(false);		  
				  c.getFragmentHeather().resetMiniCard();
			}
		}
		
		private void gestioNouTorn(boolean errorTurn, int positionInLayout,boolean isFinishTime,boolean isFinishCards)
		{
			 if (isFinishTime)
			 {
				 if (iPartida.isStateFinishGame()&&errorTurn)
				 {
				  c.getFragmentHeather().startMissatgeAnimat(c.getString(R.string.kronoscards_finishgame_time),false,true);
				 }else
				 {
					 c.getFragmentHeather().startMissatgeAnimat(c.getString(R.string.kronoscards_finishgame_time),false,false);
					 gestioFinishTime();
				 }
			 }
				counterTourn++;
				c.getFragmentHeather().setTurnIndicator(counterTourn);
					((RelativeLayout)c.findViewById(R.id.relminicard)).setVisibility(View.GONE);
					if (!errorTurn)
					{
						iPartida.setIdCartaAnterior(cartaToAdd.getId());
						iPartida.setPositionCartaAnterior(positionInLayout);
					}
					cartaToAdd=null;		
					 String cartas=Joiner.on(",").join(listCardsIds);
					 iPartida.setNumMissatge(iPartida.getNumMissatge()+1);
					iPartida.setListCardsInGame(listCardsIds);
					 Log.v("Partida","next turn listsCardsIds=  "+listCardsIds.toString());
					iPartida.setTurnCounter(counterTourn);
					if (isFinishCards) iPartida.setStateFinishGame(true);
					else iPartida.setStateFinishGame(false);
					iPartida.setErrorTurn(errorTurn);
					if (isCreator) 
					{
						iPartida.setPuntuacioCreador(c.getFragmentHeather().getMiPuntuacio());
						iPartida.setListCardsByCreator(c.getFragmentMyCards().getActualListCartes());
					}
					else 
						{
						 iPartida.setPuntuacioRival(c.getFragmentHeather().getMiPuntuacio());
						iPartida.setListCardsByOtherPlayer(c.getFragmentMyCards().getActualListCartes());
						}
					 c.getFragmentMyCards().desActivateAll();
			    	 c.getFragmentMyCards().activateScroll();
			    	 c.getFragmentHeather().switchTurnView(false);
			    	 isMyTurn=false;
			    	 menuMyCards.setVisibility(View.VISIBLE);
			    	 ((ImageView)c.findViewById(R.id.btn_mycards)).setVisibility(View.VISIBLE);
			    	 ((OutlineTextView)c.findViewById(R.id.miscardstext)).setVisibility(View.VISIBLE);
					//menuMyCards.animateToggle();
			    	 stateGenerateCardPlayer=false;
					 stateAddCard=false;
					 stateIsAddingCardToGame=false;
					 stateIsFinishTime=false;
					Gson gson = new Gson();   
					String info = gson.toJson(iPartida);   
					Log.v("Partida","Info a enviar a l'altre= "+info);
					byte[] mMsgPartida=info.getBytes();
					cartas=Joiner.on(",").join(listCardsIds);
					Log.v("Partida","cartas a la partida enviar a l'altre depres= "+cartas);
					c.enviarMissatgeReliable(mMsgPartida);
		}
		
		 private void nextTurn2(boolean errorTurn, int positionInLayout,boolean isFinishTime)
			{	
			 Log.v("States","nextTurn2");
			 if (!c.getFragmentMyCards().isFinish())
				{
				 Log.v("States","No hem acabat la ltima carta");
				 //No hem acabat la ltima carta
				 if (isCreator)
				 {
					 Log.v("States","nextTurn2 isCreator gestioNouTorn");
					 //Si soc el creador continuem el torn normal
					 gestioNouTorn(errorTurn,positionInLayout,isFinishTime,false);
					
				 }else
				 {
					 Log.v("States","nextTurn2 no soc el creador");
					//Si no soc el creador 
					 if (iPartida.isStateFinishGame())
					 {
						 Log.v("States","iPartida.isStateFinishGame()");
						 //Si el creador ha acabat hem perdut la partida
						 iPartida.setStateFinishGame(true);
						 iPartida.setErrorTurn(true);
						 iPartida.setNumMissatge(iPartida.getNumMissatge()+1);
						 iPartida.setPuntuacioRival(c.getFragmentHeather().getMiPuntuacio());
						 Gson gson = new Gson();   
							String info = gson.toJson(iPartida);   
					 	 Log.v("Partida","Info a enviar a l'altre= "+info);
					 	byte[] mMsgPartida=info.getBytes();
					 	 c.enviarMissatgeReliable(mMsgPartida);	
					 	ResultatPartida resultat=new ResultatPartida();
						resultat.setPuntuacioTotal(c.getFragmentHeather().getMiPuntuacio());
						c.setPuntuacioFinal(resultat);
					
						 c.getFragmentHeather().startMissatgeAnimat(c.getString(R.string.kronoscards_finishgame_lose),false,true);
				
					 }else
					 {
						 Log.v("States","gestioNouTorn");
						 //Si el creador no ha acabat continuem la partida normal
						 gestioNouTorn(errorTurn,positionInLayout,isFinishTime,false);									 

					 }
				 }
				 	
				}else
				{
					 Log.v("States","Hem acabat la ltima carta");
					 //Si hem tirat l'ultima carta
					if (isCreator)
					 {
						 Log.v("States","Soc creador");
						if (iPartida.getListCardsByOtherPlayer().size()>1)
						{
							Log.v("States","l'altre jugador t ms d'una carta hem guanyat");
							//Si l'altre jugador t ms d'una carta hem guanyat
							 iPartida.setStateFinishGame(true);
							 iPartida.setErrorTurn(false);
							 iPartida.setNumMissatge(iPartida.getNumMissatge()+1);
							 Gson gson = new Gson();   
								String info = gson.toJson(iPartida);   
						 	 Log.v("Partida","Info a enviar a l'altre= "+info);
						 	byte[] mMsgPartida=info.getBytes();
						 	 c.enviarMissatgeReliable(mMsgPartida);
						 	ResultatPartida resultat=new ResultatPartida();
							resultat.setWinner(true);
							resultat.setPerfect(c.getFragmentMyCards().isPerfect());
							resultat.setPuntuacioTotal(c.getFragmentHeather().getMiPuntuacio());
							c.setPuntuacioFinal(resultat);
							 c.getFragmentHeather().startMissatgeAnimat(c.getString(R.string.kronoscards_finishgame_win),true,true);
					
						}else 
						{
							Log.v("States","gestioNouTorn");
								//Entrariem a veure
						 gestioNouTorn(errorTurn,positionInLayout,isFinishTime,true);
						}
						
					 }else
					 {
						 Log.v("States","No soc el creador");
						 //No soc el creador
						 if (iPartida.isStateFinishGame())
						 {
							 Log.v("States","el creador ha acabat");
							 //Si el creador ha acabat
							 if (oPartida.isPermitirDesempate())
							 {
								 Log.v("States","oPartida.isPermitirDesempate()");
								 //Si es permet desempat tornem a posar a false el finish partida
								 gestioNouTorn(errorTurn,positionInLayout,isFinishTime,false);
							 }else
							 {
								 Log.v("States","Sino es permet desempat hem acabat per punts");
								 //Sino es permet desempat hem acabat per punts
								 iPartida.setStateFinishGame(true);
								 iPartida.setErrorTurn(false);
								 iPartida.setPuntuacioRival(c.getFragmentHeather().getMiPuntuacio());
								 iPartida.setNumMissatge(iPartida.getNumMissatge()+1);
								 Gson gson = new Gson();   
									String info = gson.toJson(iPartida);   
							 	 Log.v("Partida","Info a enviar a l'altre= "+info);
							 	byte[] mMsgPartida=info.getBytes();
							 	 c.enviarMissatgeReliable(mMsgPartida);	 
							 	ResultatPartida resultat=new ResultatPartida();
								if (c.getFragmentHeather().getMiPuntuacio()>=c.getFragmentHeather().getRivalPuntuacio())
									resultat.setWinner(true);
								else resultat.setWinner(false);
								resultat.setPerfect(c.getFragmentMyCards().isPerfect());
								resultat.setPuntuacioTotal(c.getFragmentHeather().getMiPuntuacio());
								c.setPuntuacioFinal(resultat);
								 c.getFragmentHeather().startMissatgeAnimat(c.getString(R.string.kronoscards_finishgame_winp),false,true);
					
							 }
						 }else
						 {
							 Log.v("States","Si el creador no ha acabat la partida guanyem");
							 //Si el creador no ha acabat la partida
							 iPartida.setStateFinishGame(true);
							 iPartida.setErrorTurn(false);
							 iPartida.setNumMissatge(iPartida.getNumMissatge()+1);
							 Gson gson = new Gson();   
								String info = gson.toJson(iPartida);   
						 	 Log.v("Partida","Info a enviar a l'altre= "+info);
						 	byte[] mMsgPartida=info.getBytes();
						 	 c.enviarMissatgeReliable(mMsgPartida);		
						 	ResultatPartida resultat=new ResultatPartida();
							resultat.setWinner(true);
							resultat.setPerfect(c.getFragmentMyCards().isPerfect());
							resultat.setPuntuacioTotal(c.getFragmentHeather().getMiPuntuacio());
							c.setPuntuacioFinal(resultat);
							 c.getFragmentHeather().startMissatgeAnimat(c.getString(R.string.kronoscards_finishgame_win),true,true);
				
						 }
					 }
				}
			}
		
		private Integer[] generateCartesInicials()
		{
			 Log.v("Partida","generateCartesInicials");
			 List<Integer> listIdsTotals=new ArrayList<Integer>();
			 if (oPartida.getPaquetCartes()==0)
				 listIdsTotals=c.getDatabase().getAllIdsOrderByTime(false, -1);
		       else
		    	   listIdsTotals=c.getDatabase().getAllIdsOrderByTime(true, oPartida.getPaquetCartes());
			 Log.v("Partida","listIdsTotals= "+listIdsTotals.toString());
				Integer[] cartesInicials=new Integer[oPartida.getNumInitialCards()];
			for (int i=0;i<cartesInicials.length;i++)
			{
				if (oPartida.getPaquetCartes()==0)
				{
					int idNewCard=-1;
					do
					{			
						idNewCard=UtilitatsTablero.getRandom(1,listIdsTotals.size()-1);
					}while (Arrays.asList(cartesInicials).contains(Integer.valueOf(idNewCard)));
					cartesInicials[i]=idNewCard;
				}else
				{
					int idNewCard=-1;
					 Log.v("Partida","maxNumCards= "+maxNumCards);
					do
					{			
						idNewCard=UtilitatsTablero.getRandom(1,maxNumCards);
						 Log.v("Partida","idNewCard= "+idNewCard);
						 Log.v("Partida","listIdsTotals.contains(Integer.valueOf(idNewCard))= "+listIdsTotals.contains(Integer.valueOf(idNewCard)));
						 Log.v("Partida","listIdsTotals.contains(idNewCard)= "+listIdsTotals.contains(idNewCard));
						 Log.v("Partida","Arrays.asList(cartesInicials).contains(Integer.valueOf(idNewCard)= "+Arrays.asList(cartesInicials).contains(Integer.valueOf(idNewCard)));
						 Log.v("Partida","Arrays.asList(cartesInicials).contains(idNewCard)= "+Arrays.asList(cartesInicials).contains(idNewCard));
						/* if (oPartida.getPaquetCartes()==-1) idNewCard=UtilitatsTablero.getRandom(1,listIdsTotals.size()-1);
						 else if (oPartida.getPaquetCartes()==1)*/
					}while (Arrays.asList(cartesInicials).contains(Integer.valueOf(idNewCard))||!listIdsTotals.contains(Integer.valueOf(idNewCard)));
					cartesInicials[i]=idNewCard;
				}
			}
			 Log.v("Partida","cartesInicials= "+Arrays.toString(cartesInicials));
			Integer[] listPosition=new Integer[oPartida.getNumInitialCards()];
			
			for (int i=0;i<cartesInicials.length;i++)
			{
				listPosition[i]=listIdsTotals.indexOf(cartesInicials[i]);
			}
			 Log.v("Partida","listPosition= "+Arrays.toString(listPosition));
			while (!isOrdenat(listPosition))
			{
				for (int i=0;i<cartesInicials.length-1;i++)
				{
					if (listPosition[i]>listPosition[i+1]) 
					{
						int valueTemp=listPosition[i+1];
						listPosition[i+1]=listPosition[i];
						listPosition[i]=valueTemp;
						int valueTemp2=cartesInicials[i+1];
						cartesInicials[i+1]=cartesInicials[i];
						cartesInicials[i]=valueTemp2;
					}
				}
			}
			 Log.v("Partida","cartesInicials finals= "+Arrays.toString(cartesInicials));
			return cartesInicials;
		}
		private boolean isOrdenat(Integer[] listPositions)
		{
			 
			for (int i=0;i<listPositions.length-1;i++)
			{
				if (listPositions[i]>listPositions[i+1]) return false;
			}
			Log.v("Partida","isOrdenat=true");
			return true;
		}
		private List<List<Integer>> getCartesByDificultat()
		{
			List<Carta> listCartas;
			 if (oPartida.getPaquetCartes()==0)
				 listCartas=c.getDatabase().getAllCardsOrderByTime(false, -1);
		       else
		    	   listCartas=c.getDatabase().getAllCardsOrderByTime(true, oPartida.getPaquetCartes());
		
			 List<Integer> listIdsTotas=new ArrayList<Integer>();
			for (int i=0;i<iPartida.getCartesInicials().length;i++)
			{
				listIdsTotas.add(iPartida.getCartesInicials()[i]);
			}
			List<List<Integer>> listTotals=new ArrayList<List<Integer>>();
			int multiplicadorDificultat=0;
			int position1=0,position2=0,position3=0,position4=0,position5=0;
			Integer[] listIdsPlayer1=new Integer[oPartida.getMaxCards()];
			Integer[] listIdsPlayer2=new Integer[oPartida.getMaxCards()];
			Integer[] listIdsPlayer3=new Integer[oPartida.getMaxCards()];
			Integer[] listIdsPlayer4=new Integer[oPartida.getMaxCards()];
			Integer[] listIdsPlayer5=new Integer[oPartida.getMaxCards()];
			for (int i=0;i<oPartida.getMaxCards();i++)
			{
				position1=UtilitatsTablero.getRandom(0,listCartas.size()-1);
				if (oPartida.getDificultat()==0) multiplicadorDificultat=UtilitatsTablero.getRandom(1,10);
				else if (oPartida.getDificultat()==1) multiplicadorDificultat=UtilitatsTablero.getRandom(1,5);
				else if (oPartida.getDificultat()==2) multiplicadorDificultat=UtilitatsTablero.getRandom(1,2);				
					if (oPartida.getNumPlayers()==2)
					{
							while (listIdsTotas.contains(listCartas.get(position1).getId()))
							{
								position1=position1+1;
								if (position1>=listCartas.size()) position1=position1-listCartas.size();
							}
							listIdsPlayer1[i]=listCartas.get(position1).getId();
							listIdsTotas.add(listIdsPlayer1[i]);
							position2=position1+multiplicadorDificultat;
							if (position2>=listCartas.size()) position2=position2-listCartas.size();
							while (listIdsTotas.contains(listCartas.get(position2).getId()))
							{
								position2=position2+1;
								if (position2>=listCartas.size()) position2=position2-listCartas.size();
							}
							listIdsPlayer2[i]=listCartas.get(position2).getId();						
							listIdsTotas.add(listIdsPlayer2[i]);
					}else if (oPartida.getNumPlayers()==3)
					{
						while (listIdsTotas.contains(listCartas.get(position1).getId()))
						{
							position1=position1+1;
							if (position1>=listCartas.size()) position1=position1-listCartas.size();
						}
						listIdsPlayer1[i]=listCartas.get(position1).getId();
						listIdsTotas.add(listIdsPlayer1[i]);
						position2=position1+multiplicadorDificultat;
						if (position2>=listCartas.size()) position2=position2-listCartas.size();
						while (listIdsTotas.contains(listCartas.get(position2).getId()))
						{
							position2=position2+1;
							if (position2>=listCartas.size()) position2=position2-listCartas.size();
						}
						listIdsPlayer2[i]=listCartas.get(position2).getId();
						listIdsTotas.add(listIdsPlayer2[i]);
						position3=position2+multiplicadorDificultat;
						if (position3>=listCartas.size()) position3=position3-listCartas.size();
						while (listIdsTotas.contains(listCartas.get(position3).getId()))
						{
							position3=position3+1;
							if (position3>=listCartas.size()) position3=position3-listCartas.size();
						}
						listIdsPlayer3[i]=listCartas.get(position3).getId();
						listIdsTotas.add(listIdsPlayer3[i]);
					}else if (oPartida.getNumPlayers()==4)
					{
						while (listIdsTotas.contains(listCartas.get(position1).getId()))
						{
							position1=position1+1;
							if (position1>=listCartas.size()) position1=position1-listCartas.size();
						}
						listIdsPlayer1[i]=listCartas.get(position1).getId();
						listIdsTotas.add(listIdsPlayer1[i]);
						position2=position1+multiplicadorDificultat;
						if (position2>=listCartas.size()) position2=position2-listCartas.size();
						while (listIdsTotas.contains(listCartas.get(position2).getId()))
						{
							position2=position2+1;
							if (position2>=listCartas.size()) position2=position2-listCartas.size();
						}
						listIdsPlayer2[i]=listCartas.get(position2).getId();
						listIdsTotas.add(listIdsPlayer2[i]);
						position3=position2+multiplicadorDificultat;
						if (position3>=listCartas.size()) position3=position3-listCartas.size();
						while (listIdsTotas.contains(listCartas.get(position3).getId()))
						{
							position3=position3+1;
							if (position3>=listCartas.size()) position3=position3-listCartas.size();
						}
						listIdsPlayer3[i]=listCartas.get(position3).getId();
						listIdsTotas.add(listIdsPlayer3[i]);
						position4=position3+multiplicadorDificultat;
						if (position4>=listCartas.size()) position4=position4-listCartas.size();
						while (listIdsTotas.contains(listCartas.get(position4).getId()))
						{
							position4=position4+1;
							if (position4>=listCartas.size()) position4=position4-listCartas.size();
						}
						listIdsPlayer4[i]=listCartas.get(position4).getId();
						listIdsTotas.add(listIdsPlayer4[i]);
					}else if (oPartida.getNumPlayers()==5)
					{
						while (listIdsTotas.contains(listCartas.get(position1).getId()))
						{
							position1=position1+1;
							if (position1>=listCartas.size()) position1=position1-listCartas.size();
						}
						listIdsPlayer1[i]=listCartas.get(position1).getId();
						listIdsTotas.add(listIdsPlayer1[i]);
						position2=position1+multiplicadorDificultat;
						if (position2>=listCartas.size()) position2=position2-listCartas.size();
						while (listIdsTotas.contains(listCartas.get(position2).getId()))
						{
							position2=position2+1;
							if (position2>=listCartas.size()) position2=position2-listCartas.size();
						}
						listIdsPlayer2[i]=listCartas.get(position2).getId();
						listIdsTotas.add(listIdsPlayer2[i]);
						position3=position2+multiplicadorDificultat;
						if (position3>=listCartas.size()) position3=position3-listCartas.size();
						while (listIdsTotas.contains(listCartas.get(position3).getId()))
						{
							position3=position3+1;
							if (position3>=listCartas.size()) position3=position3-listCartas.size();
						}
						listIdsPlayer3[i]=listCartas.get(position3).getId();
						listIdsTotas.add(listIdsPlayer3[i]);
						position4=position3+multiplicadorDificultat;
						if (position4>=listCartas.size()) position4=position4-listCartas.size();
						while (listIdsTotas.contains(listCartas.get(position4).getId()))
						{
							position4=position4+1;
							if (position4>=listCartas.size()) position4=position4-listCartas.size();
						}
						listIdsPlayer4[i]=listCartas.get(position4).getId();
						listIdsTotas.add(listIdsPlayer4[i]);
						position5=position4+multiplicadorDificultat;
						if (position5>=listCartas.size()) position5=position5-listCartas.size();
						while (listIdsTotas.contains(listCartas.get(position5).getId()))
						{
							position5=position5+1;
							if (position5>=listCartas.size()) position5=position5-listCartas.size();
						}
						listIdsPlayer5[i]=listCartas.get(position5).getId();
						listIdsTotas.add(listIdsPlayer5[i]);
					}
				
			}
			if (oPartida.getNumPlayers()==2)
			{
				listTotals.add(Lists.newArrayList(listIdsPlayer1));
				listTotals.add(Lists.newArrayList(listIdsPlayer2));
			}else if (oPartida.getNumPlayers()==3)
			{
				listTotals.add(Lists.newArrayList(listIdsPlayer1));
				listTotals.add(Lists.newArrayList(listIdsPlayer2));
				listTotals.add(Lists.newArrayList(listIdsPlayer3));
			}else if (oPartida.getNumPlayers()==4)
			{
				listTotals.add(Lists.newArrayList(listIdsPlayer1));
				listTotals.add(Lists.newArrayList(listIdsPlayer2));
				listTotals.add(Lists.newArrayList(listIdsPlayer3));
				listTotals.add(Lists.newArrayList(listIdsPlayer4));
			}else if (oPartida.getNumPlayers()==5)
			{
				listTotals.add(Lists.newArrayList(listIdsPlayer1));
				listTotals.add(Lists.newArrayList(listIdsPlayer2));
				listTotals.add(Lists.newArrayList(listIdsPlayer3));
				listTotals.add(Lists.newArrayList(listIdsPlayer4));
				listTotals.add(Lists.newArrayList(listIdsPlayer5));
				
			}
			Log.v("Cartes","Cartes Repartides primerJugador= "+Arrays.toString(listIdsPlayer1));
			Log.v("Cartes","Cartes Repartides segonJugador= "+Arrays.toString(listIdsPlayer2));
			Log.v("Cartes","Cartes Repartides tercerJugador= "+Arrays.toString(listIdsPlayer3));
			Log.v("Cartes","Cartes Repartides quartJugador= "+Arrays.toString(listIdsPlayer4));
			Log.v("Cartes","Cartes Repartides cinqueJugador= "+Arrays.toString(listIdsPlayer5));
			Log.v("Cartes","Cartes Repartides listTotals= "+listTotals.toString());
			return listTotals;
		}

		public void startGame() {
			Log.v("Partida","startGame is Creator= "+isCreator);
			if (isCreator)
	        {
				gestioIniciPartida();
	        }
		}
		private void gestioIniciPartida()
		{
			Log.v("Partida","gestioIniciPartida");
			iPartida=new InfoPartida();
			iPartida.setOpcions(oPartida);
			Integer[] cartesInicials=generateCartesInicials();
			iPartida.setCartesInicials(cartesInicials);
			List<List<Integer>> listPlayersCards=getCartesByDificultat();
			   myPlayer.setListCards(listPlayersCards.get(0));
			 iPartida.setCardsPerRepartir(listPlayersCards.get(1));
			 iPartida.setNumMissatge(iPartida.getNumMissatge()+1);
			 iPartida.setListCardsByCreator(listPlayersCards.get(0).subList(0,oPartida.getNumCardsByPlayer()));
			 iPartida.setListCardsByOtherPlayer(listPlayersCards.get(1).subList(0,oPartida.getNumCardsByPlayer()));
			 c.getFragmentRivalCards().reloadCartes(iPartida.getListCardsByOtherPlayer());
			 iPartida.setOpcions(oPartida);
			 Gson gson = new Gson();   
				String info = gson.toJson(iPartida);   
	    	 Log.v("Partida","Info a enviar a l'altre= "+info);
	    	 byte[] mMsgPartida=info.getBytes();
	    	 c.enviarMissatgeReliable(mMsgPartida);
		}
		
		 private void  gestioPartidaIniciada()
		    {
			 
			  partidaIniciada=true;
			  c.stopDialog();
		    	 Log.v("MyCards","Aqu comenaria el joc!!!!!! ");
		    	 //if (c.getFragmentMyCards()!=null&&!c.getFragmentMyCards().noInit())
	        	 //{
		    	 c.getFragmentHeather().showMessage(c.getString(R.string.kronoscards_game_repartjugador));
		    	
		      	 ((RelativeLayout)c.findViewById(R.id.relmycards)).setVisibility(View.VISIBLE);
		      	Handler handler = new Handler(); 
			 	    handler.postDelayed(new Runnable() { 
			 	         public void run() {
			 	        	 c.getFragmentMyCards().open(false);
			 	        	Handler handler = new Handler(); 
					 	    handler.postDelayed(new Runnable() { 
					 	         public void run() {
					 	        	c.getFragmentMyCards().initFragment(myPlayer.getListCards());
							 	      }
						 	       }, 500);
			 	        	
					 	      }
				 	       }, 500);
		        	
	        	// }
		    	 
		    }
		
		private void addNewCardToMyScroll()
		{
			final int positionInLayout=iPartida.getPositionCartaAnterior();
			
			Log.v("Partida","addNewCardToMyScroll");
			if (c.getFragmentMyCards().isOpened())
			{
				c.getFragmentMyCards().close(false,true);
				
			}
			Handler handler = new Handler(); 
	 	    handler.postDelayed(new Runnable() { 
	 	         public void run() {
	 	        	 new Handler().post(new Runnable() {
	 		            @Override
	 		            public void run() {
	 		            	RelativeLayout view=null;
	 		            	if (positionInLayout>tablero.getChildCount()) view=(RelativeLayout) tablero.getChildAt(positionInLayout-1);
	 		            	else view=(RelativeLayout) tablero.getChildAt(positionInLayout);
	 		            	
	 		            	//UtilitatsTablero.focusOnView(scroll,view);
	 		            	scroll.smoothScrollTo(0, view.getRight());
	 		            	Integer idCardAnterior=iPartida.getIdCartaAnterior();
		 					Log.v("Partida","idCardAnterior = "+idCardAnterior);
		 					Log.v("Partida","listCartsInGame = "+iPartida.getListCardsInGame());
		 					if (!idCardAnterior.equals(Integer.valueOf(-1)))
		 					{
		 						int positionCard=-0;
		 						for(Integer card:iPartida.getListCardsInGame())
		 						{
		 							Log.v("Partida","Comparacio idCardAnterior =" +idCardAnterior+ "  card= "+card);
		 							Log.v("Partida","idCardAnterior==card " +(idCardAnterior==card));;
		 							if (idCardAnterior.equals(card)) break;
		 							positionCard++;
		 						}
		 						Log.v("Partida","positionCard = "+positionCard);
		 						listCardsIds.add(positionCard,idCardAnterior);
		 						Log.v("Partida","listCardsIds.add = "+listCardsIds.toString());
		 						Carta carta=c.getDatabase().getCartaById(""+idCardAnterior);
		 						RelativeLayout card1=UtilitatsTablero.getRelForCard(carta,c,true);
		 						card1.setVisibility(View.VISIBLE);
		 						/*if (positionCard==0) positionInLayout=0;*/
		 						 if (positionInLayout==0)
		 			     		 {
		 			     			 RelativeLayout viewSatellite = UtilitatsTablero.getNewSatelliteMenu(c);
		 			     			 viewSatellite.setVisibility(View.GONE);
		 			     			 tablero.addView(card1, 1);
		 			     			 tablero.addView(viewSatellite,2);
		 			     			
		 			     		 }else if (positionInLayout==maxElements-1)
		 			     		 {
		 			     			 RelativeLayout viewSatellite = UtilitatsTablero.getNewSatelliteMenu(c);
		 			     			 viewSatellite.setVisibility(View.GONE);
		 			     			 tablero.addView(card1, maxElements);
		 			     			 tablero.addView(viewSatellite,maxElements+1);
		 			     		 }else
		 			     		 {
		 			     			 RelativeLayout viewSatellite = UtilitatsTablero.getNewSatelliteMenu(c);
		 			     			 viewSatellite.setVisibility(View.GONE);
		 			     			 tablero.addView(card1, positionInLayout+1);
		 			     			 tablero.addView(viewSatellite,positionInLayout+2); 
		 			     		 }
		 						 c.getFragmentHeather().switchTurnView(true);
		 					}else
		 					{
		 						c.showGameError(getString(R.string.kronoscards_general_error));
		 					}
	 		               // scroll.smoothScrollTo(0, view.getRight());
	 		            }
	 	        	 });
	 		           
	 		       
			 	      }
		 	       }, 1000);
			
			//else   menuMyCards.setVisibility(View.GONE);
			 /*new Handler().post(new Runnable() {
		            @Override
		            public void run() {
		            	RelativeLayout view=null;
		            	if (positionInLayout>tablero.getChildCount()) view=(RelativeLayout) tablero.getChildAt(positionInLayout-1);
		            	else view=(RelativeLayout) tablero.getChildAt(positionInLayout);
		            	
		            	UtilitatsTablero.focusOnView(scroll,view);
		               // scroll.smoothScrollTo(0, view.getRight());
		            }
		        });*/
			
		}

		public void cancelMiniCard() {
			isMyTurn=true;
			closeAllButtons();
			c.getUtils().disableEnableControls(false, relGeneral);
			setAllMenusState(false);
			cartaToAdd=null;
			menuMyCards.setVisibility(View.GONE);
			((OutlineTextView)c.findViewById(R.id.miscardstext)).setVisibility(View.VISIBLE);
			if (!c.getFragmentMyCards().isOpened())c.getFragmentMyCards().open(false);
			Handler handler2 = new Handler(); 
		    handler2.postDelayed(new Runnable() { 
		         public void run() {
		        	 c.getFragmentMyCards().cancelCarta();
		         } 
		    }, 500);
						
		}

		public void computeScroll(SatelliteMenu satelliteMenu) {
			closeAllButtons();
			//UtilitatsTablero.focusOnView(scroll,(RelativeLayout)satelliteMenu.getParent());
		}

		

		

		 @Override         	
		 public void onDestroyView() {
			 tablero.removeAllViews();
		  Log.v("finish","onDestroyView Tablero ");
		 
			super.onDestroyView();
	  }

		

		

		

	  
	  
}
