package com.kronoscards.kcmain;

import java.util.ArrayList;
import java.util.List;

import com.google.android.gms.games.Games;
import com.google.android.gms.games.GamesActivityResultCodes;
import com.google.android.gms.games.GamesStatusCodes;
import com.google.android.gms.games.multiplayer.Invitation;
import com.google.android.gms.games.multiplayer.Multiplayer;
import com.google.android.gms.games.multiplayer.OnInvitationReceivedListener;
import com.google.android.gms.games.multiplayer.Participant;
import com.google.android.gms.games.multiplayer.realtime.RealTimeMessage;
import com.google.android.gms.games.multiplayer.realtime.RealTimeMessageReceivedListener;
import com.google.android.gms.games.multiplayer.realtime.RealTimeMultiplayer.ReliableMessageSentCallback;
import com.google.android.gms.games.multiplayer.realtime.Room;
import com.google.android.gms.games.multiplayer.realtime.RoomConfig;
import com.google.android.gms.games.multiplayer.realtime.RoomStatusUpdateListener;
import com.google.android.gms.games.multiplayer.realtime.RoomUpdateListener;
import com.google.example.games.basegameutils.BaseGameActivity;
import com.kronoscards.db.Database;
import com.kronoscards.fragments.Fragment_EndGame;
import com.kronoscards.fragments.Fragment_Heather;
import com.kronoscards.fragments.Fragment_Instrucciones;
import com.kronoscards.fragments.Fragment_Login;
import com.kronoscards.fragments.Fragment_MainScreen;
import com.kronoscards.fragments.Fragment_MyCards;
import com.kronoscards.fragments.Fragment_OpcionsPartida;
import com.kronoscards.fragments.Fragment_RivalsCards;
import com.kronoscards.fragments.Fragment_Splash;
import com.kronoscards.fragments.Fragment_Tablero;
import com.kronoscards.pack.AppValors;
import com.kronoscards.pack.ResultatPartida;
import com.kronoscards.pack.Utilitats;
import com.kronoscards.pack.UtilitatsTablero;

import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentTransaction;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;

public class MainActivity extends BaseGameActivity  implements RealTimeMessageReceivedListener,
RoomStatusUpdateListener,
RoomUpdateListener,OnInvitationReceivedListener{

	 FragmentManager fm;
	 int numFragment=-1;
	 Fragment_Heather fHeather;
	 Fragment_MyCards fMyCards;
	 Fragment_RivalsCards fRivalsCards;
	 Fragment_Tablero fTablero;
	 
	 
	 AppValors appValors=new AppValors();
	 Utilitats utils=new Utilitats();
	 UtilitatsTablero utilsTablero=new UtilitatsTablero();
	 
	 Database d;
	 Context c;
	 
	 final static String TAG = "KronosCards";
	 
	 //Gesti de Creaci de Room
	 ProgressDialog mDialogGeneral;
	 final static int RC_INVITATION_INBOX = 10001;
	 final static int RC_WAITING_ROOM = 10002;
	 final static int RC_SELECT_PLAYERS = 10000;
	  String mRoomId = null;
	  String mIncomingInvitationId = null;
	  String mMyId = null;
	  String otherPlayerId=null;
	  String idCreador="";
	  private boolean isConnected=false;
	  private boolean isCreator=false;
	  private boolean isPartidaRapida=false;
	  private boolean isMissatgeEnviat=false;
	  private boolean firstMisRebut=false;
	  // The participants in the currently active game
	    ArrayList<Participant> mParticipants = null;
	 // at least 2 players required for our game
	    final static int MIN_PLAYERS = 2;
	    final static int MAX_PLAYERS = 2;
	    
	    private boolean outRoom=true;
	    private ResultatPartida puntuacionLastPartida=new ResultatPartida();
	    
	   
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		Log.v("Timeline", "Principal onCreate");
		c=this;
		d=new Database(c);
		boolean existeix=d.comprovarBasedeDades();
		appValors.init(c);
		utils.keepScreenOn(c);
		fm=getSupportFragmentManager();
		try
		{
		FragmentTransaction ft = fm.beginTransaction();      
	       Fragment_Splash fSplash=new Fragment_Splash();
	        ft.add(R.id.fragment_splash, fSplash);
	        ft.commit();
	       /* if (!appValors.getPrefsKC().getBoolean("firstTime", true))
	        {*/
		        FragmentTransaction ft2 = fm.beginTransaction();      
			       Fragment_Login fLogin=new Fragment_Login();
			       ft2.add(R.id.fragment_content_general, fLogin);
			       ft2.commit();
	      //  }
		}catch (Exception e)
		{
			
		}
		
	}
	public Fragment_Heather getFragmentHeather() {
		return fHeather;
	}
	public Fragment_MyCards getFragmentMyCards() {
		return fMyCards;
		
	}
	public Fragment_RivalsCards getFragmentRivalCards() {
		return fRivalsCards;
	}
	public Fragment_Tablero getFragmentTablero() {
		return fTablero;
	}

	public void setNumFragment(int numFragment) {
		this.numFragment = numFragment;
	}
	public AppValors getAppValors() {
		return appValors;
	}
	public void setAppValors(AppValors appValors) {
		this.appValors = appValors;
	}
	
	
	public Database getDatabase() {
		return d;
	}
	
	public Utilitats getUtils() {
		return utils;
	}

	public UtilitatsTablero getUtilsTablero() {
		return utilsTablero;
	}
	
	public boolean isRoomLeaved()
	{
		return outRoom;
	}
	
	
	//Interacci
	/*public void closeFragmentRivalsCards(boolean quickly) {
		fRivalsCards.close(quickly);
		
	}*/
	/*public void openFragmentMyCards(boolean quickly) {
		fMyCards.open(quickly);
		
	}*/
	/*public void initProves() {
		fTablero.initTablero();
		
	}*/
	public void finishSplash(Fragment fDestroy) {
		try
		{
			 if (appValors.getPrefsKC().getBoolean("firstTime", true))
			 {
				 appValors.getPrefsKC().edit().putBoolean("firstTime", false).commit();
			 }
			 if (fDestroy!=null)
				{
					fm.beginTransaction().setCustomAnimations(0,R.anim.out_animation_slow).remove(fDestroy).commit();
				}
			((FrameLayout) findViewById(R.id.fragment_splash)).setVisibility(View.GONE);
			
		}catch (Exception e)
		{
			
		}
	}
	 @Override
	    public void onStop() {
	        Log.d(TAG, "**** got onStop");
	        utils.stopKeepingScreenOn(c);
	        if (isConnected)
	        {
			   leaveRoom(true);
			   
	        }  
	        //signOut();
	        super.onStop();
	    }
	 @Override
	    public void onDestroy() {
	        Log.d(TAG, "**** got onDestroy");
	        utils.stopKeepingScreenOn(c);
	        if (numFragment==5)
	        {
			   leaveRoom(true);
	        }  
	        
	        super.onDestroy();
	    }
	
	 public void initPuntuacioLastPartida()
	 {
		 puntuacionLastPartida=new ResultatPartida();
	 }
	 public ResultatPartida getPuntuacioLastPartida()
	 {
		 return puntuacionLastPartida;
	 }
	 public void setPuntuacioFinal(ResultatPartida res)
	 {
		 puntuacionLastPartida=res;
	 }
	 @Override
	    public void onResume() {
		 Log.v("Timeline", "Principal onResume create");
	        super.onResume();
	    }
	    
	public void startGameTablero() {
		Log.v("Partida","startGameTablero");
		((LinearLayout)findViewById(R.id.invitation_popup)).setVisibility(View.GONE);
		try
		{
			 if (mDialogGeneral!=null) mDialogGeneral.setMessage(getString(R.string.kronoscards_alerta_recibiendocartas));
		        else
		        {
		        	 mDialogGeneral = new ProgressDialog(c);
		    		 mDialogGeneral.requestWindowFeature(Window.FEATURE_NO_TITLE);
		    		 mDialogGeneral.setMessage(getString(R.string.kronoscards_alerta_recibiendocartas));
		    		 mDialogGeneral.setCancelable(false);
		    		 mDialogGeneral.show();
		        }
			 fTablero=new Fragment_Tablero();
			 fHeather=new Fragment_Heather();
			 fMyCards=new Fragment_MyCards();
			 fRivalsCards=new Fragment_RivalsCards();
			 fm.beginTransaction().setCustomAnimations(R.anim.in_animation1,R.anim.out_animation1).replace(R.id.fragment_content_general, fTablero).commit();
			 Handler handler = new Handler(); 
		 	    handler.postDelayed(new Runnable() { 
		 	         public void run() { 
		 	        	 fm.beginTransaction().add(R.id.fragment_barra_dalt, fHeather).commit();  
		 	         }
		 	       }, 500);
		 	   Handler handler3 = new Handler(); 
		 	    handler3.postDelayed(new Runnable() { 
		 	         public void run() { 
		 	        	 fm.beginTransaction().add(R.id.fragment_mycards, fMyCards).commit();  
		 				 fm.beginTransaction().add(R.id.fragment_rivalcards, fRivalsCards).commit();
		 				Log.v("Partida","isCreator= "+isCreator);
		 				if (isCreator)
		 				{
		 					Log.v("Partida","isCreator= "+isCreator);
		 					fTablero.setCreatorValues(true);
		 				}
		 				fTablero.startGame();
		 	         }
		 	       }, 1500);
		 	   Handler handler2 = new Handler(); 
			    handler2.postDelayed(new Runnable() { 
			         public void run() {
			        	 if (!firstMisRebut)
			        	 {
			        		 leaveRoom(false);
			        		 //enviarMissatgeUnreliable(mMsgPartida);
			        	 }
			         } 
			    }, 15000);
		}catch (Exception e)
		{
			
		}
		
	}
	public void showFragmentOpciones() {
  	  Fragment fragment=new Fragment_OpcionsPartida();
		    	fm.beginTransaction().setCustomAnimations(R.anim.in_animation1,R.anim.out_animation1).replace(R.id.fragment_content_general, fragment).commit();
	}
	public void showFragmentInstrucciones() {
		 Fragment fragment=new Fragment_Instrucciones();
	    	fm.beginTransaction().setCustomAnimations(R.anim.in_animation1,R.anim.out_animation1).replace(R.id.fragment_content_general, fragment).commit();
		
	}
	    private void  setFragmentLogin()
	    {
	    	if (numFragment!=0)
	    	{
			    	  Fragment fLogin=new Fragment_Login();
			    	fm.beginTransaction().setCustomAnimations(R.anim.transition_alphadown,R.anim.transition_alphaup).replace(R.id.fragment_content_general, fLogin).commit();
					
	    	}
	    }
	    private void  setFragmentMainScreen()
	    {
	    	
	    	if (numFragment!=1)
	    	{
			    	  Fragment fragment=new Fragment_MainScreen();
			    	fm.beginTransaction().setCustomAnimations(R.anim.transition_alphadown,R.anim.transition_alphaup).replace(R.id.fragment_content_general, fragment).commit();
			}else stopDialog();
	    }
	    public void  returnFragmentMainScreen()
	    {
	    	
	    	
			    	  Fragment fragment=new Fragment_MainScreen();
			    	fm.beginTransaction().setCustomAnimations(R.anim.in_animation,R.anim.out_animation).replace(R.id.fragment_content_general, fragment).commit();
		
	    }
	    
	    @Override
	    public void onSignInFailed() {
	        Log.v("Timeline", "Sign-in failed.");
	        setFragmentLogin();
	    }
	    /**
	     * Called by the base class (BaseGameActivity) when sign-in succeeded. We
	     * react by going to our main screen.
	     */
	    @Override
	    public void onSignInSucceeded() {
	        Log.v("Timeline", "Sign-in succeeded.");

	        // register listener so we are notified if we receive an invitation to play
	        // while we are in the game
	        Games.Invitations.registerInvitationListener(getApiClient(), this);

	        // if we received an invite via notification, accept it; otherwise, go to main screen
	        if (getInvitationId() != null) {
	            acceptInviteToRoom(getInvitationId());
	            return;
	        }
	        if (numFragment==0&&numFragment!=1)
	        setFragmentMainScreen();
	    }
	   
	   
		
		
	
		
		
		
		
		
		
		
		
		
		
		
		
		
	
	  
	    private void returnFragmentMainScreenFromGame()
	    {
	    	
	    		
	    	
	    	 Log.v("finish","returnFragmentMainScreen ");
	    	if (numFragment!=1)
	    	{
	    		try
		    	{
		    		if (numFragment==5)
		    		{   Fragment fragment=new Fragment_EndGame();
						fm.beginTransaction().setCustomAnimations(R.anim.in_animation,R.anim.out_animation).replace(R.id.fragment_content_general, fragment).commit();
						fm.beginTransaction().setCustomAnimations(0,R.anim.out_animation_slow).remove(fMyCards).commit();
						fm.beginTransaction().setCustomAnimations(0,R.anim.out_animation_slow).remove(fRivalsCards).commit();
						((RelativeLayout)findViewById(R.id.relmycards)).setVisibility(View.INVISIBLE);
						fHeather.initAnimationsFragment(true);
						Handler handler2 = new Handler(); 
					    handler2.postDelayed(new Runnable() { 
					         public void run() {
					        	 try
							    	{
					        	 fm.beginTransaction().setCustomAnimations(0,R.anim.out_animation_slow).remove(fHeather).commit();
							    	}catch (Exception e)
							    	{
							    		finish();
							    	}
					         } 
					    }, 1500);
		    			
		    		}else
		    		{
		    			  Fragment fragment=new Fragment_MainScreen();
		    				fm.beginTransaction().setCustomAnimations(R.anim.in_animation,R.anim.out_animation).replace(R.id.fragment_content_general, fragment).commit();
		    		}	
		    	}catch (Exception e)
		    	{
		    		finish();
		    	}
					
	    	}else
	    	{
	    		
	    		stopDialog();
	    	}
	    }
	    
	    public void callAlert(String message){
			
			 AlertDialog.Builder adb = new AlertDialog.Builder(c);
				adb.setCancelable(false);
		     adb.setMessage(message);
		     adb.setPositiveButton(getString(R.string.kronoscards_aceptar_button), new DialogInterface.OnClickListener() { //Boton Positivio 
		         
		         public void onClick(DialogInterface dialog, int which) {
		        	 dialog.dismiss();
		         }
			});
				adb.show();	
			}
	    @Override
	    protected void onSaveInstanceState(Bundle outState) {
	        //No call for super(). Bug on API Level > 11.
	    }
		@Override
		public void onInvitationReceived(Invitation invitation) {
			  Log.v("Login", "onInvitationReceived.");
			 mIncomingInvitationId = invitation.getInvitationId();
		        ((TextView) findViewById(R.id.incoming_invitation_text)).setText(
		                invitation.getInviter().getDisplayName() + " " +
		                        getString(R.string.kronoscards_main_invitation_retar));
								((Button)findViewById(R.id.button_accept_popup_invitation)).setEnabled(true);
		        ((Button)findViewById(R.id.button_accept_popup_invitation)).setOnClickListener(new OnClickListener(){
					@Override
					public void onClick(View v) {
						 ((LinearLayout)findViewById(R.id.invitation_popup)).setVisibility(View.GONE);
						 acceptInviteToRoom(mIncomingInvitationId);
			                mIncomingInvitationId = null;
					}
		        	
		        });
		        ((LinearLayout)findViewById(R.id.invitation_popup)).setVisibility(View.VISIBLE);
			
		}


		@Override
		public void onInvitationRemoved(String invitationId) {
			  Log.v("Login", "onInvitationRemoved");
			 if (mIncomingInvitationId.equals(invitationId)) {
		            mIncomingInvitationId = null;
		            ((LinearLayout)findViewById(R.id.invitation_popup)).setVisibility(View.GONE);
		        }
		}


		public void loginGoogle() {
			 beginUserInitiatedSignIn();
			
		}

		
		public void showInvitations() {			
			resetGameValues();
			isPartidaRapida=false;
			 mDialogGeneral = new ProgressDialog(c);
			 mDialogGeneral.requestWindowFeature(Window.FEATURE_NO_TITLE);
			 mDialogGeneral.setMessage(getString(R.string.kronoscards_alerta_invitaciones));
			 mDialogGeneral.setCancelable(false);
			 mDialogGeneral.show();
			Intent intent = Games.Invitations.getInvitationInboxIntent(getApiClient());        
	        startActivityForResult(intent, RC_INVITATION_INBOX);
			
		}
	//Procs d'invitaci
		public void inviteFriends() {
			Log.v("Game", "inviteFriends");
			resetGameValues();
			isCreator=true;
			isPartidaRapida=false;
			
	        // show list of invitable players
	        mDialogGeneral = new ProgressDialog(c);
			 mDialogGeneral.requestWindowFeature(Window.FEATURE_NO_TITLE);
			 mDialogGeneral.setMessage(getString(R.string.kronoscards_alerta_listaamigos));
			 mDialogGeneral.setCancelable(false);
			 mDialogGeneral.show();
	        Intent intent = Games.RealTimeMultiplayer.getSelectOpponentsIntent(getApiClient(), 1, 3);
	      
	        startActivityForResult(intent, RC_SELECT_PLAYERS);
	 
			
			
		}
		  // Handle the result of the invitation inbox UI, where the player can pick an invitation
	    // to accept. We react by accepting the selected invitation, if any.
	    private void handleInvitationInboxResult(int response, Intent data) {
	        if (response != Activity.RESULT_OK) {
	            Log.v("Game", "*** invitation inbox UI cancelled, " + response);
	            
	            returnFragmentMainScreenFromGame();
	            return;
	        }

	        Log.v("Game", "Invitation inbox UI succeeded.");
	        Invitation inv = data.getExtras().getParcelable(Multiplayer.EXTRA_INVITATION);
	        //Invitation inv = data.getExtras().getParcelable(GamesClient.EXTRA_INVITATION);

	        // accept invitation
	        acceptInviteToRoom(inv.getInvitationId());
	    }

	    // Accept the given invitation.
	    void acceptInviteToRoom(String invId) {
	    				// accept the invitation
	        Log.d(TAG, "Accepting invitation: " + invId);
	        RoomConfig.Builder roomConfigBuilder = RoomConfig.builder(this);
	        roomConfigBuilder.setInvitationIdToAccept(invId)
	                .setMessageReceivedListener(this)
	                .setRoomStatusUpdateListener(this);
	        if (mDialogGeneral!=null) mDialogGeneral.setMessage(getString(R.string.kronoscards_alerta_salaesperaentrat));
	        else
	        {
	        	 mDialogGeneral = new ProgressDialog(c);
	    		 mDialogGeneral.requestWindowFeature(Window.FEATURE_NO_TITLE);
	    		 mDialogGeneral.setMessage(getString(R.string.kronoscards_alerta_salaesperaentrat));
	    		 mDialogGeneral.setCancelable(false);
	    		 mDialogGeneral.show();
	        }
	        resetGameValues();
	        Games.RealTimeMultiplayer.join(getApiClient(), roomConfigBuilder.build());
	    }
	    
	    //Metodes de RoomUpdateListener 
		@Override
		public void onJoinedRoom(int statusCode, Room room) {
			 Log.d(TAG, "onJoinedRoom(" + statusCode + ", " + room + ")");
		        if (statusCode != GamesStatusCodes.STATUS_OK) {
		            Log.e(TAG, "*** Error: onRoomConnected, status " + statusCode);
		            showGameError(getString(R.string.kronoscards_general_error));
		            return;
		        }

		        
		        // show the waiting room UI
		        showWaitingRoom(room);
		}
		@Override
		public void onLeftRoom(int statusCode, String roomId) {
			Log.d(TAG, "onLeftRoom, code " + statusCode);
			 outRoom=true;
			 resetGameValues();
			//leaveRoom(false);
		}
		@Override
		public void onRoomConnected(int statusCode, Room room) {
			  //fTablero.setPartidaIniciadaState(false);
			  Log.d(TAG, "onRoomConnected(" + statusCode + ", " + room + ")");
		        if (statusCode != GamesStatusCodes.STATUS_OK) {
		            Log.e(TAG, "*** Error: onRoomConnected, status " + statusCode);
		            showGameError(getString(R.string.kronoscards_general_error));
		            return;
		        }
		        updateRoom(room);
		}
		@Override
		public void onRoomCreated(int statusCode, Room room) {		
			  Log.d(TAG, "onRoomCreated(" + statusCode + ", " + room + ")");
		        if (statusCode != GamesStatusCodes.STATUS_OK)  {
		            Log.e(TAG, "*** Error: onRoomCreated, status " + statusCode);
		            showGameError(getString(R.string.kronoscards_general_error));
		            return;
		        }

		        // show the waiting room UI
		        showWaitingRoom(room);
		}
		
		void updateRoom(Room room) {
			 Log.v("UpRoom", "updateRoom ");
	        if (room != null) {
	        	Log.v("UpRoom", "room != null ");
	            mParticipants = room.getParticipants();
	        }
	        if (mParticipants != null) {
	        	Log.v("UpRoom", "mParticipants != null num= "+mParticipants.size());
	           // updatePeerScoresDisplay();
	        }
	    }
		void showWaitingRoom(Room room) {
			 Log.d(TAG, "showWaitingRoom");
	    	 if (room==null) Log.d(TAG, "room==null");
	        // minimum number of players required for our game
	        // For simplicity, we require everyone to join the game before we start it
	        // (this is signaled by Integer.MAX_VALUE).
	        //final int MIN_PLAYERS = Integer.MAX_VALUE;
	    	 
	        Intent i = Games.RealTimeMultiplayer.getWaitingRoomIntent(getApiClient(), room, MIN_PLAYERS);

	        // show waiting room UI
	        startActivityForResult(i, RC_WAITING_ROOM);
	    }
		
		  // Handle the result of the "Select players UI" we launched when the user clicked the
	    // "Invite friends" button. We react by creating a room with those players.
	    private void handleSelectPlayersResult(int response, Intent data) {
	        if (response != Activity.RESULT_OK) {
	            Log.w(TAG, "*** select players UI cancelled, " + response);
	            returnFragmentMainScreenFromGame();
	            return;
	        }

	        Log.d(TAG, "Select players UI succeeded.");

	        // get the invitee list
	       //
	        final ArrayList<String> invitees = data.getStringArrayListExtra(Games.EXTRA_PLAYER_IDS);
	        Log.d(TAG, "Invitee count: " + invitees.size());

	        // get the automatch criteria
	        Bundle autoMatchCriteria = null;
	        int minAutoMatchPlayers = data.getIntExtra(Multiplayer.EXTRA_MIN_AUTOMATCH_PLAYERS, 0);
	        int maxAutoMatchPlayers = data.getIntExtra(Multiplayer.EXTRA_MAX_AUTOMATCH_PLAYERS, 0);
	        //int minAutoMatchPlayers = data.getIntExtra(GamesClient.EXTRA_MIN_AUTOMATCH_PLAYERS, 0);
	        //int maxAutoMatchPlayers = data.getIntExtra(GamesClient.EXTRA_MAX_AUTOMATCH_PLAYERS, 0);
	        if (minAutoMatchPlayers > 0 || maxAutoMatchPlayers > 0) {
	            autoMatchCriteria = RoomConfig.createAutoMatchCriteria(
	                    minAutoMatchPlayers, maxAutoMatchPlayers, 0);
	            Log.d(TAG, "Automatch criteria: " + autoMatchCriteria);
	        }

	        // create the room
	        Log.d(TAG, "Creating room...");
	        RoomConfig.Builder rtmConfigBuilder = RoomConfig.builder(this);
	        rtmConfigBuilder.addPlayersToInvite(invitees);
	        rtmConfigBuilder.setMessageReceivedListener(this);
	        rtmConfigBuilder.setRoomStatusUpdateListener(this);
	        if (autoMatchCriteria != null) {
	            rtmConfigBuilder.setAutoMatchCriteria(autoMatchCriteria);
	        }
	        mDialogGeneral.setMessage(getString(R.string.kronoscards_alerta_creandosala));
	        //keepScreenOn();
	        resetGameValues();
	        Games.RealTimeMultiplayer.create(getApiClient(), rtmConfigBuilder.build());
	        Log.d(TAG, "Room created, waiting for it to be ready...");
	    }

		  @Override
		    public void onActivityResult(int requestCode, int responseCode,
		            Intent intent) {
		        super.onActivityResult(requestCode, responseCode, intent);

		        switch (requestCode) {	    
		        case RC_SELECT_PLAYERS:
	                // we got the result from the "select players" UI -- ready to create the room
	                handleSelectPlayersResult(responseCode, intent);
	                break;
		            case RC_INVITATION_INBOX:
		                // we got the result from the "select invitation" UI (invitation inbox). We're
		                // ready to accept the selected invitation:
		                handleInvitationInboxResult(responseCode, intent);
		                break;
		            case RC_WAITING_ROOM:
		                // we got the result from the "waiting room" UI.
		                if (responseCode == Activity.RESULT_OK) {
		                					// ready to start playing
		                    Log.d(TAG, "Starting game (waiting room returned OK).");
		                    startGameTablero();
		                } else if (responseCode == GamesActivityResultCodes.RESULT_LEFT_ROOM) {
		                	  Log.d(TAG, "RESULT_LEFT_ROOM");
		                			// player indicated that they want to leave the room
		                    leaveRoom(false);
		                } else if (responseCode == Activity.RESULT_CANCELED) {
		                	Log.d(TAG, "RESULT_CANCELED");
				                    // Dialog was cancelled (user pressed back key, for instance). In our game,
				                    // this means leaving the room too. In more elaborate games, this could mean
				                    // something else (like minimizing the waiting room UI).
		                	 leaveRoom(false);
		                }
		                break;
		           
		        }
		    }
		 
		  public void startQuickGame() {
			  resetGameValues();
			  isPartidaRapida=true;
			   final int MIN_OPPONENTS = 1, MAX_OPPONENTS = 1;
		        Bundle autoMatchCriteria = RoomConfig.createAutoMatchCriteria(MIN_OPPONENTS,
		                MAX_OPPONENTS, 0);
		        RoomConfig.Builder rtmConfigBuilder = RoomConfig.builder(this);
		        rtmConfigBuilder.setMessageReceivedListener(this);
		        rtmConfigBuilder.setRoomStatusUpdateListener(this);
		        rtmConfigBuilder.setAutoMatchCriteria(autoMatchCriteria);
		        mDialogGeneral = new ProgressDialog(c);
				 mDialogGeneral.requestWindowFeature(Window.FEATURE_NO_TITLE);
				 mDialogGeneral.setMessage(getString(R.string.kronoscards_alerta_buscando));
				 mDialogGeneral.setCancelable(false);
				 mDialogGeneral.show();  
				 try
				 {
					 Games.RealTimeMultiplayer.create(getApiClient(), rtmConfigBuilder.build());
				 }catch (Exception e)
				 {
					 AlertDialog.Builder adb = new AlertDialog.Builder(c);
						adb.setCancelable(false);
				     adb.setMessage(getString(R.string.kronoscards_general_error_apidesonected));
				     adb.setPositiveButton(getString(R.string.kronoscards_aceptar_button), new DialogInterface.OnClickListener() { //Boton Positivio 
				         
				         public void onClick(DialogInterface dialog, int which) {
				        	 setFragmentLogin();
				        	 dialog.dismiss();
				         }
					});
					 mDialogGeneral.dismiss();
					    Log.d(TAG, "Super Excepcio!!! "+e.getMessage());
				 }
			
		}
 
		  
		  
		   // Leave the room.
		    public void leaveRoom(boolean isStoping) {
		    	  Log.v("Leave", "Leaving room.");
		       // mSecondsLeft = 0;
		       // stopKeepingScreenOn();
		        if (mRoomId != null&&isConnected) {
		        	          
				        // cancel the game
						isConnected=false;
				     
		        	  Log.v("Leave", "mRoomId != null");
		            Games.RealTimeMultiplayer.leave(getApiClient(), this, mRoomId);
		            
		            resetGameValues();
		           // mDialogGeneral.setMessage(getString(R.string.kronoscards_alerta_saliendosala));
		           // returnFragmentMainScreen();
		            if(!isStoping) returnFragmentMainScreenFromGame();
		        } else {
		        	isConnected=false;
		        	 resetGameValues();
		        	  Log.v("Leave", "mRoomId == null");
		        	if(!isStoping)returnFragmentMainScreenFromGame();
		        }
		    }
		  private void resetGameValues()
		  {  
			  firstMisRebut=false;
			  mRoomId = null;
			  mIncomingInvitationId = null;
		  	  mMyId = null;
		  	  otherPlayerId=null;
		  	  idCreador="";
		  	  isCreator=false;
		  }
		  public void showGameError(String missatge) {
		        showAlert(missatge);
		        returnFragmentMainScreenFromGame();
		        resetGameValues();
		    }
		
		    // Clears the flag that keeps the screen on.
		  

			public void stopDialog() {
				if (mDialogGeneral!=null)
				{
					try
					{
					mDialogGeneral.dismiss();
					}catch (Exception e)
					{
						
					}
				}
				
			}

			
			
			
			

			@Override
			public void onConnectedToRoom(Room room) {
				  Log.d(TAG, "onConnectedToRoom.");
				  if (mDialogGeneral!=null) mDialogGeneral.setMessage(getString(R.string.kronoscards_alerta_recibiendocartas));
			        else
			        {
			        	 mDialogGeneral = new ProgressDialog(c);
			    		 mDialogGeneral.requestWindowFeature(Window.FEATURE_NO_TITLE);
			    		 mDialogGeneral.setMessage(getString(R.string.kronoscards_alerta_recibiendocartas));
			    		 mDialogGeneral.setCancelable(false);
			    		 mDialogGeneral.show();
			        }
			        // get room ID, participants and my ID:
			        mRoomId = room.getRoomId();
			        mParticipants = room.getParticipants();
			        mMyId = room.getParticipantId(Games.Players.getCurrentPlayerId(getApiClient()));
			        idCreador=room.getCreatorId();
			        isConnected=true;
			        outRoom=false;
			        // print out the list of participants (for debug purposes)
			        Log.d(TAG, "Room ID: " + mRoomId);
			        Log.d(TAG, "My ID " + mMyId);
			        Log.d(TAG, "<< CONNECTED TO ROOM>>");
			        
			        Log.v("Player","onConnectedToRoom");
			        Log.v("Player","Player id= "+mMyId);
			        Log.v("Player","Creator id= "+idCreador);
			        if (!isPartidaRapida)
			        {
			        	 
			        	if (mMyId.compareTo(idCreador)==0)
			        	{
			        		isCreator=true;
			        	}else isCreator=false;
			        	Log.v("Player","!isPartidaRapida is Creator= " +isCreator);
			        }else 
			        {
			        	otherPlayerId="";
			        	for (Participant player:mParticipants)
			        	{
			        		if (player.getParticipantId().compareTo(mMyId)!=0)
			        		{
			        			otherPlayerId=player.getParticipantId();
			        		}
			        	}
			        	if (otherPlayerId.compareTo(mMyId)>0)
			        	{
			        		isCreator=true;
			        	}else isCreator=false;
			        	Log.v("Player","s partida rpida is Creator= " +isCreator);
			        }
				
			}


			@Override
			public void onDisconnectedFromRoom(Room room) {
				 Log.d(TAG, "onDisconnectedFromRoom   mRoomId = null");
				 //mRoomId = null;
				 if (isConnected)
				 {
					 isConnected=false;
				  Games.RealTimeMultiplayer.leave(getApiClient(), this, mRoomId);
				  showGameError("onDisconnectedFromRoom");
				 }
				
			}


			@Override
			public void onP2PConnected(String participantId) {
				Log.d(TAG, "onP2PConnected");
			}
			@Override
			public void onP2PDisconnected(String participantId) {
				Log.d(TAG, "onP2PDisconnected");
			}
			@Override
			public void onPeerDeclined(Room room, List<String> arg1) {
				Log.d(TAG, "onPeerDeclined");
				  //updateRoom(room);
				if (shouldCancelGame(room)&&isConnected) {
			        // cancel the game
					isConnected=false;
			        Games.RealTimeMultiplayer.leave(getApiClient(), this, mRoomId);
			        showGameError("onPeersDisconnected");
			    }
			}
			@Override
			public void onPeerInvitedToRoom(Room room, List<String> arg1) {
				Log.d(TAG, "onPeerInvitedToRoom");
				  updateRoom(room);			
			}
			@Override
			public void onPeerJoined(Room room, List<String> arg1) {
				Log.d(TAG, "onPeerJoined");
				 updateRoom(room);
			}
			@Override
			public void onPeerLeft(Room room, List<String> arg1) {
				Log.d(TAG, "onPeerLeft");
				// updateRoom(room);
				if (shouldCancelGame(room)&&isConnected) {
			        // cancel the game
					isConnected=false;
			        Games.RealTimeMultiplayer.leave(getApiClient(), this, mRoomId);
			        showGameError("onPeerLeft");
			    }
			}
			@Override
			public void onPeersConnected(Room room, List<String> arg1) {
				Log.d(TAG, "onPeersConnected");
				  updateRoom(room);
			}
			boolean shouldCancelGame(Room room) {
					int connectedPlayers = 0;
			    for (Participant p : room.getParticipants()) {
			        if (p.isConnectedToRoom()) ++connectedPlayers;
			    }
			    return connectedPlayers < MIN_PLAYERS;	
			    }
			@Override
			public void onPeersDisconnected(Room room, List<String> arg1) {
				Log.d(TAG, "onPeersDisconnected");
				 // updateRoom(room);
				if (shouldCancelGame(room)&&isConnected) {
			        // cancel the game
					isConnected=false;
			        Games.RealTimeMultiplayer.leave(getApiClient(), this, mRoomId);
			        showGameError("onPeersDisconnected");
			    }
			}
			@Override
			public void onRoomAutoMatching(Room room) {
				Log.d(TAG, "onRoomAutoMatching");
				 updateRoom(room);
			}
			@Override
			public void onRoomConnecting(Room room) {
				Log.d(TAG, "onRoomConnecting");
				 updateRoom(room);
			}
			@Override
			public void onRealTimeMessageReceived(RealTimeMessage message) {
				
				Log.v("Partida","onRealTimeMessageReceived");
		    	if (mParticipants.size()==2)
		    	{
		    		if (!firstMisRebut)
		    		{
		    			Log.v("Partida","First missatge rebut");
		    			firstMisRebut=true;
		    		}
		    			
		    		
		    		fTablero.onRealTimeMessageReceived2(message);
		    	}else 
		    	{
		    		if (isConnected) {
				        // cancel the game
						isConnected=false;
				        Games.RealTimeMultiplayer.leave(getApiClient(), this, mRoomId);
				        showGameError("onPeersDisconnected");
				    }
		    	}
				
			}
			
			
			  

			
		
			public void enviarMissatgeUnreliable(byte[] mMsgPartida) {
				//enviarMissatgeReliable(mMsgPartida);
				Log.v("Partida","enviarMissatgeUnreliable");
				 if (mParticipants.get(0).getParticipantId().compareTo(mMyId)!=0)
		    	 {
		    	 Games.RealTimeMultiplayer.sendUnreliableMessage(getApiClient(), mMsgPartida, mRoomId,
		    			 mParticipants.get(0).getParticipantId());
		    	 }else
		    	 {
		    		 Games.RealTimeMultiplayer.sendUnreliableMessage(getApiClient(), mMsgPartida, mRoomId,
		    				 mParticipants.get(1).getParticipantId());
		    	 }	
				
			}

			public void enviarMissatgeReliable(final byte[] mMsgPartida) {
				isMissatgeEnviat=false;
				Log.v("Partida","enviarMissatgeReliable");
				 if (mParticipants.get(0).getParticipantId().compareTo(mMyId)!=0)
		    	 {
					 Log.v("Partida","enviarMissatgeReliable a participant 0 id= "+mParticipants.get(0).getParticipantId());
		    	 Games.RealTimeMultiplayer.sendReliableMessage(getApiClient(),new ReliableMessageSentCallback() {
		             @Override
		             public void onRealTimeMessageSent(int statusCode, int tokenId, String recipientParticipantId) {
		                 switch (statusCode) {
		                 case GamesStatusCodes.STATUS_OK:
		                	 isMissatgeEnviat=true;
		                     Log.v("Partida", " Missatge enviat STATUS_OK");
		                     break;
		                 case GamesStatusCodes.STATUS_REAL_TIME_MESSAGE_SEND_FAILED:
		                	 isMissatgeEnviat=true;
		                	 enviarMissatgeUnreliable(mMsgPartida);
		                	 
		                     Log.v("Missatge", "Missatge enviat STATUS_REAL_TIME_MESSAGE_SEND_FAILED");
		                     break;
		                 case GamesStatusCodes.STATUS_REAL_TIME_ROOM_NOT_JOINED:
		                	 isMissatgeEnviat=true;
		                	 leaveRoom(false);
		                     Log.v("Missatge", "Missatge enviat STATUS_REAL_TIME_ROOM_NOT_JOINED");
		                     break;
		                  default:   Log.v("Missatge", "Missatge enviat un altre status= "+ statusCode);
		                	  
		                 }
		             }
		         },mMsgPartida, mRoomId, mParticipants.get(0).getParticipantId());
		    	 }else
		    	 {
		    		 Log.v("Partida","enviarMissatgeReliable a participant 1 id= "+mParticipants.get(1).getParticipantId());
		    		 Games.RealTimeMultiplayer.sendReliableMessage(getApiClient(),new ReliableMessageSentCallback() {
			             @Override
			             public void onRealTimeMessageSent(int statusCode, int tokenId, String recipientParticipantId) {
			                 switch (statusCode) {
			                 case GamesStatusCodes.STATUS_OK:
			                	 isMissatgeEnviat=true;
			                	  Log.v("Partida", " Missatge enviat STATUS_OK");
			                     break;
			                 case GamesStatusCodes.STATUS_REAL_TIME_MESSAGE_SEND_FAILED:
			                	 isMissatgeEnviat=true;
			                	 enviarMissatgeUnreliable(mMsgPartida);
			                	  Log.v("Missatge", "Missatge enviat STATUS_REAL_TIME_MESSAGE_SEND_FAILED");
			                     break;
			                 case GamesStatusCodes.STATUS_REAL_TIME_ROOM_NOT_JOINED:
			                	 isMissatgeEnviat=true;
			                	 leaveRoom(false);
			                	  Log.v("Missatge", "Missatge enviat STATUS_REAL_TIME_ROOM_NOT_JOINED");
			                     break;
			                 default:   Log.v("Missatge", "Missatge enviat un altre status= "+ statusCode);
			                 }
			             }
			         },mMsgPartida, mRoomId, mParticipants.get(1).getParticipantId());
		    		// Games.RealTimeMultiplayer.sendUnreliableMessage(getApiClient(), mMsgPartida, mRoomId,
		    				 
		    	 }	
				 Handler handler2 = new Handler(); 
				    handler2.postDelayed(new Runnable() { 
				         public void run() {
				        	 if (!isMissatgeEnviat)
				        	 {
				        		 leaveRoom(false);
				        		 //enviarMissatgeUnreliable(mMsgPartida);
				        	 }
				         } 
				    }, 10000);
				
			}

			
			private void gestioBack()
			{
				if (numFragment==0||numFragment==1)
				{
					  AlertDialog.Builder adb = new AlertDialog.Builder(c);
						adb.setCancelable(false);
				     adb.setMessage(getString(R.string.kronoscards_game_salir));
				     adb.setPositiveButton(getString(R.string.kronoscards_aceptar_button), new DialogInterface.OnClickListener() { //Boton Positivio 
				         
				         public void onClick(DialogInterface dialog, int which) {
				        	 finish();
				        	 dialog.dismiss();
				         }
					});
				     adb.setNegativeButton(getString(R.string.kronoscards_cancelar_button), new DialogInterface.OnClickListener() { //Boton Positivio 
				         
				         public void onClick(DialogInterface dialog, int which) {
				        	 dialog.dismiss();
				         }
					});
						adb.show();	
				}else if (numFragment==5)
				{
					leaveRoom(false);
				}else if (numFragment==2)
				{
					try
					{
					  Fragment_OpcionsPartida activity = (Fragment_OpcionsPartida) getSupportFragmentManager().findFragmentById(R.id.fragment_content_general);
				       	activity.backPressed();
				          }catch(ClassCastException e)
				          {	        	   
				          }
				}else if (numFragment==3)
				{
					try
					{
					  Fragment_Instrucciones activity = (Fragment_Instrucciones) getSupportFragmentManager().findFragmentById(R.id.fragment_content_general);
				       	activity.backPressed();
				          }catch(ClassCastException e)
				          {	        	   
				          }
				}else if (numFragment==4)
				{
					try
					{
					  Fragment_EndGame activity = (Fragment_EndGame) getSupportFragmentManager().findFragmentById(R.id.fragment_content_general);
				       	activity.backPressed();
				          }catch(ClassCastException e)
				          {	        	   
				          }
				}
			}
			 @Override
			    public boolean onKeyDown(int keyCode, KeyEvent event)  {
			      
					 if(keyCode == KeyEvent.KEYCODE_BACK){
						 gestioBack();
						
						 	
					    }
					
			            return true;
				}
			
			
			
		

}
