package com.kronoscards.pack;

import java.util.HashMap;

import android.content.Context;
import android.media.AudioManager;
import android.media.SoundPool;
import android.media.SoundPool.OnLoadCompleteListener;
import android.os.Handler;
import android.util.Log;



public class SoundManagerGeneral {
	
	private  SoundPool mSoundPool; 
	private  HashMap<Integer, Integer> mSoundPoolMap; 
	private  AudioManager  mAudioManager;
	private  Context mContext;
	static private SoundManagerGeneral _instance;

	int soundPlaying=0;
	
	public SoundManagerGeneral()
	{
		
	}
	static synchronized public SoundManagerGeneral getInstance()
	{
	    if (_instance == null)
	      _instance = new SoundManagerGeneral();
	    return _instance;
	 }

		
	public void initSounds(Context theContext) { 
		 mContext = theContext;	     
	     mSoundPoolMap = new HashMap<Integer, Integer>(); 
	     mAudioManager = (AudioManager)theContext.getSystemService(Context.AUDIO_SERVICE);
	     mSoundPool = new SoundPool(1, AudioManager.STREAM_MUSIC, 0);
	} 
	
	public void addSound(int Index,int SoundID)
	{
		mSoundPoolMap.put(Index, mSoundPool.load(mContext, SoundID, 1));
	}
	
	public void addSoundFromFile(int Index,String path)
	{
		mSoundPoolMap.put(Index, mSoundPool.load(path, 1));
	}
	
	public void playSound(int index) {	
		soundPlaying=index;
		float streamVolume=5;
	     streamVolume = mAudioManager.getStreamVolume(AudioManager.STREAM_MUSIC);
	     streamVolume = streamVolume / mAudioManager.getStreamMaxVolume(AudioManager.STREAM_MUSIC);
	     mSoundPool.play(mSoundPoolMap.get(index), streamVolume, streamVolume, 1, 0, 1f); 
	}
	
	public void stopReleaseSound() {
		
	    // int streamVolume = mAudioManager.getStreamVolume(AudioManager.STREAM_MUSIC); 
	    // mSoundPool.stop(index); 
	     mSoundPool.release();
	}
	public void stopSound()
	{
		mSoundPool.stop(soundPlaying);
	}
	
	public void playLoopedSound(int index) { 
		
	     int streamVolume = mAudioManager.getStreamVolume(AudioManager.STREAM_MUSIC); 
	     mSoundPool.play(mSoundPoolMap.get(index), streamVolume, streamVolume, 1, -1, 1f);
	     
	}
	public void playSoundNotReadyLooped(int index,int SoundID) {
		mSoundPool.load(mContext, SoundID, 1);
		mSoundPool.setOnLoadCompleteListener(new OnLoadCompleteListener() {
		    public void onLoadComplete(SoundPool soundPool, int sampleId,int status) {
		    	 Log.v("Ready","onLoadComplete ");
		    	 soundPlaying=mSoundPool.play(sampleId, 1, 1, 1, 0, 1f);
		    }
		});
	}
		public void playSoundNotReady(int index,int SoundID) {
			mSoundPool.load(mContext, SoundID, 0);
			mSoundPool.setOnLoadCompleteListener(new OnLoadCompleteListener() {
			    public void onLoadComplete(SoundPool soundPool, int sampleId,int status) {
			    	 Log.v("Ready","onLoadComplete normal ");
			    	 mSoundPool.play(sampleId, 1, 1, 0, 0, 1f);
			    }
			});
		}
		
		public void playSoundDelayed(int index,int SoundID) {
			mSoundPool.load(mContext, SoundID, 0);
			mSoundPool.setOnLoadCompleteListener(new OnLoadCompleteListener() {
			    public void onLoadComplete(SoundPool soundPool, final int sampleId,int status) {
			    	 Log.v("Ready","onLoadComplete post delayed ");
			    	 Handler handler = new Handler(); 
					    handler.postDelayed(new Runnable() { 
					         public void run() { 	
					        	 Log.v("Ready","run()");
					        	 mSoundPool.play(sampleId, 1, 1, 0, 0, 1f);
					         } 
					    }, 1000); 
			    	
			    }
			});
		}
		
		public void playSoundLooped(int index,int SoundID) {
			mSoundPool.load(mContext, SoundID, 0);
			mSoundPool.setOnLoadCompleteListener(new OnLoadCompleteListener() {
			    public void onLoadComplete(SoundPool soundPool, int sampleId,int status) {
			    	 Log.v("Ready","onLoadComplete ");
			    	 mSoundPool.play(sampleId, 1, 1, 0, -1, 1f);
			    }
			});
		}
	
	
}