package com.kronoscards.pack;

import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.Random;

import android.annotation.SuppressLint;
import android.content.Context;
import android.graphics.Color;
import android.os.Build;
import android.os.Handler;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ImageView;
import android.widget.RelativeLayout;

import com.kronoscards.adaptscreen.AutoResizeTextView;
import com.kronoscards.adaptscreen.GradientColorKronos;
import com.kronoscards.adaptscreen.GradientsKronos;
import com.kronoscards.adaptscreen.MyHorizontalScrollView;
import com.kronoscards.kcmain.MainActivity;
import com.kronoscards.kcmain.R;
import com.kronoscards.satelitemenu.SatelliteMenu;
import com.kronoscards.satelitemenu.SatelliteMenuItem;
import com.kronoscards.satelitemenu.SatelliteMenu.SateliteClickedListener;

public class UtilitatsTablero {

	 public static List<Carta> listCartas=new ArrayList<Carta>();
	 static GradientsKronos gradientsList=new GradientsKronos();
	 
	 public static void init(Context c)
	 {
		 gradientsList.init(c); 
	 }
	
	@SuppressLint("NewApi")
	public static RelativeLayout getRelForCard(Carta carta,Context c,boolean isTablero)
	{
		 LayoutInflater layoutInflater = (LayoutInflater)c.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		 RelativeLayout viewInflate = (RelativeLayout) layoutInflater.inflate(R.layout.inflate_card, null);
		 AutoResizeTextView titulo=(AutoResizeTextView)viewInflate.findViewById(R.id.titulo);
			titulo.setTypeface(((MainActivity)c).getAppValors().getTipoMyriad());
			AutoResizeTextView ano=(AutoResizeTextView)viewInflate.findViewById(R.id.ano);
			ano.setTypeface(((MainActivity)c).getAppValors().getTipoMyriad());
			if (!isTablero) ano.setVisibility(View.GONE);
			 int position=getPositionByYear(Long.parseLong(carta.getAny()));
			 Log.v("Gradient","Gradient position= "+position);
			 GradientColorKronos gd=null;
			if (isTablero) gd =gradientsList.getListGradients().get(position);
			else gd = gradientsList.getListGradients().get(50);
			
				if(Build.VERSION.SDK_INT < Build.VERSION_CODES.JELLY_BEAN) {
					ano.setBackgroundDrawable(GradientsKronos.NewGradient(gd,5,2,Color.WHITE));
	    		} else {
	    			 ano.setBackground(GradientsKronos.NewGradient(gd,5,2,Color.WHITE));
	    		}	
		
			
			 ano.setTextColor(gd.getTextColor());    
			 ano.setShadowLayer(2f, 2f, 2f, gd.getColorA());
			 String anyText=carta.getAny().trim();
			 long anyNum=Long.parseLong(anyText);
			 Log.v("Any","Any= "+anyNum);
			 if (anyText.trim().startsWith("-"))
			 {
				 Log.v("Any","startsWith Any= "+carta.getAny().trim());
				 long anyNormal=Math.abs(anyNum);
				 if (anyNormal>9999)
				 {
					 if (anyNormal>1000000)
					 {
						 RelativeLayout.LayoutParams relParams=(RelativeLayout.LayoutParams) ano.getLayoutParams();
						 relParams.setMargins(10, relParams.topMargin, 10, relParams.bottomMargin);
						 ano.setLayoutParams(relParams);
					 }
					 String thousText=formatDecimal(anyNormal);
					 ano.setText("-"+thousText);
				 }else
				 {
					 ano.setText("-"+anyNormal);
				 }
				 ;
			 }else	 ano.setText(carta.getAny().trim());
			 
			 if(Build.VERSION.SDK_INT < Build.VERSION_CODES.JELLY_BEAN) {
				 titulo.setBackgroundDrawable(GradientsKronos.NewGradient(gd,5,2,Color.WHITE));
	    		} else {
	    			titulo.setBackground(GradientsKronos.NewGradient(gd,5,2,Color.WHITE));
	    		}	
				
					titulo.setTextColor(gd.getTextColor());    
					titulo.setShadowLayer(2f, 2f, 2f, gd.getColorA());				
					titulo.setText(carta.getTitulo());
					if (!isTablero) titulo.setVisibility(View.INVISIBLE);
					ImageView foto=(ImageView)viewInflate.findViewById(R.id.fotocarta);
					Log.v("Carta","getImage="+carta.getImage());
					if (carta.getImage()!=null) foto.setImageResource(getDrawable(carta.getImage(),c));
					viewInflate.setVisibility(View.INVISIBLE);
			 return viewInflate;
	}
	public static int getPositionByYear(Long any)
	{
		 List<Carta> listCartasTemp=new ArrayList<Carta>();
		 listCartasTemp=getListCartesRemoveEqualsAnys(listCartas);
		 int position=0;
		 for (position=0;position<listCartasTemp.size();position++)
		 {
			 if (any==Long.parseLong(listCartasTemp.get(position).getAny())) break;
		 }
		 return (position*254)/listCartasTemp.size();
	}
	private static List<Carta> getListCartesRemoveEqualsAnys(List<Carta> llistat)
	{
		List<Long> listAnys=new ArrayList<Long>();
		 List<Carta> listCartastemp=new ArrayList<Carta>();
		 for (Carta carta:llistat)
			{
			 if (!listAnys.contains(Long.parseLong(carta.getAny())))
			 {
				 listCartastemp.add(carta);
				 listAnys.add(Long.parseLong(carta.getAny()));
			 }
			}
		 return listCartastemp;
	}
	public static String formatDecimal(long number) {
		 DecimalFormatSymbols otherSymbols = new DecimalFormatSymbols(Locale.GERMAN);
		// otherSymbols.setDecimalSeparator(',');
		 otherSymbols.setGroupingSeparator('.');
		
		NumberFormat f = NumberFormat.getInstance(Locale.GERMAN);
		 if (f instanceof DecimalFormat) {
		     ((DecimalFormat)f).setDecimalSeparatorAlwaysShown(false);
		     ((DecimalFormat)f).setDecimalFormatSymbols(otherSymbols);
		 }
		 
		 
		 return f.format(number);
	}
	public static int getDrawable(String name,Context c) {
	    return c.getResources().getIdentifier(name, "drawable", c.getPackageName());
	    
	}
	public static int getRandom(int min,int max)
	{
		Random rand = new Random();
		return rand.nextInt(max - min + 1) + min;
	}
	
	public static int getPercentatge(int value,int percentatge)
	{
		return ((value*percentatge)/100);
	}
	
	  public static RelativeLayout getNewSatelliteMenu(final Context c)
			{
				 LayoutInflater layoutInflater = (LayoutInflater)c.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				 final RelativeLayout rel = (RelativeLayout) layoutInflater.inflate(R.layout.inflate_satelitemenu, null);
				 SatelliteMenu menu=(SatelliteMenu)rel.findViewById(R.id.menu1);
				 rel.setTag("Menu");
				 if (((MainActivity)c).getAppValors().isHdpi())
				 {
				 menu.setSatelliteDistance(100);
				  menu.setTotalSpacingDegree(180f);
				  menu.setMeasuredWitdh(100);
				  menu.setMeasuredHeight(300);
				 }else if (((MainActivity)c).getAppValors().isXhdpi())
				 {
				 menu.setSatelliteDistance(150);
				  menu.setTotalSpacingDegree(180f);
				  menu.setMeasuredWitdh(100);
				  menu.setMeasuredHeight(440);
				 }
				  List<SatelliteMenuItem> items = new ArrayList<SatelliteMenuItem>();
			        items.add(new SatelliteMenuItem(1, R.drawable.btn_ok));
			        items.add(new SatelliteMenuItem(2, R.drawable.btn_ko));
			        menu.addItems(items);
			        menu.setOnItemClickedListener(new SateliteClickedListener() {
						
						public void eventOccured(int id) {
							
							switch(id)
							{
							case 2:						
								break;
							case 1:((MainActivity)c).getFragmentTablero().checkCard(rel);
													
								break;					
								default:							
									break;
							}
						}
					});
			        
			        return rel;
			}
	  public final static void focusOnView(final MyHorizontalScrollView sv, final View v) {
		    new Handler().post(new Runnable() {
		        @Override
		        public void run() {
		            int vLeft = v.getLeft();
		            int vRight = v.getRight();
		            int width = v.getWidth();
		            sv.smoothScrollTo(((vLeft + vRight) / 2) - (width), 0);
		        }
		    });
		}
}
